/*     标准代码提供者
 归属：企通前端平台-ECP V5.1
 版权：2014-2020 企通软件技术有限公司
 --------------------------------------------------------------------------------
 作者：纪青君                         创建日期：2014/03/13
 修改：                               修改日期：
 修改内容
 --------------------------------------------------------------------------------
 这里向使用者提供根据代码ID，获得代码的方法getSC(scID)
 scID 符合XXXX,xx`xx`xx...的定义规则
 输入参数scID包含的项不同，你得到的结果也不同，例如：
 getSC（XXXX），你可能得到的是一个代码数组或代码树。
 getSC(XXXX,xx)，你可能得到的是一个具体的代码值，也可能你得到的还是一个代码
 数组或代码树，这样依据你的代码结构而定。
 
 !!!! 目前采用程序直接量的方式定义各种代码，最终将改为从参数中读取，但对外接口将保持不变
 --------------------------------------------------------------------------------
 修改： liux                              修改日期：2014/04/30
 修改内容
 getSC方法修改为使用参数工厂从参数库中读取一个代码。
 指定的scID可以使一个代码参数的GUID，也可以是某个代码参数中的任意子节点的sGUID。
 但是该方法返回的是参数的json形式对象或json对象的数组,而不是一个model对象。
 --------------------------------------------------------------------------------
 //0XXX：控件公共信息
 //1XXX：容器控件
 //2XXX：基本控件
 //3XXX：自定义控件
 //4XXX：布局属性
 //5XXX: 图形控件
 //6XXX—8XXX:保留
 //9XXX:公共
 
 *******************************************************************************/
import React from 'react';
import ReactDOM from 'react-dom';
import * as sgiCommon from './sgiCommon';
import { PrmFactory } from '../sgiFactory/PrmFactory';
import { Resource } from './Resource';
var SCMap = {};

var StandardCode = {

    getSC: function (scID) {
    	/**
        if (!scID) {
            return null;
        }
        if (typeof (scID) != "string") {
            return null;
        }
        var sc = Ep.SCMap.get(scID);
        if (!sc) {
            sc = Ep.PrmFactory.getPrmJsonNoLocal(scID);
            if (!sc) {
                return null;
            } else {
                sc.te = Ep.getTR(sc.te).te;
                Ext.each(sc.cldSet, function(record) {
                    record.te = Ep.getTR(record.te).te;
                });
                Ep.SCMap.add(scID, sc);
            }
        }
        **/
        var sc = this.getFullSC(scID);

        if (!sc) {
            return null;
        }

        if (sc.cldSet) {
            return sc.cldSet;
        } else {
            sc.cldSet = [];
            return sc.cldSet;
        }
    },
    getFullSC: function (scID) {
        if (!scID) {
            return null;
        }
        if (typeof (scID) != "string") {
            return null;
        }
        var sc = SCMap[scID];
        if (!sc) {
            sc = PrmFactory.getPrm(scID);
            if (!sc) {
                return null;
            } else {
                sc.te = Resource.getTR(sc.te).te;
                var array = sc.cldSet;
                if (array) {
                    array.forEach((record) => {
                        record.te = Resource.getTR(record.te).te;
                    });
                }
                SCMap[scID] = sc;
            }
        }
        if (sc) {
            return sc;
        } else {
            return {};
        }
    },
    contains: function (scID) {
        var scList = this.getSC(scID);
        if (!scList) {
            return false;
        }
        if (scList.length > 0) {
            return true;
        } else {
            return false;
        }
    },
    delSC: function (scID) {
        if (!scID) {
            return null;
        }
        delete this.SCMap[scID];
    },
    setSC: function (scID, sc) {
        if (!scID) {
            return null;
        }
        var oldSc = SCMap[scID];
        if (!oldSc) {
            // SCMap.removeAtKey(scID);
            delete this.SCMap[scID];
        }
        SCMap[scID] = sc;
    },
}
export { StandardCode };