import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input } from 'antd';
const FormItem = Form.Item;
// import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
// import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
import { Button, Badge, Tooltip } from 'antd';
import { SgiEventHandler } from './SgiEventHandler'
import { Resource } from '../sgiCommon/Resource';
import { addCtnCommonAttribute } from '../sgiComp/SgiCtnComm';

class SgiButton extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state
        this.state = {
            tooltiProps: {},
            text: undefined,
            inputprops: {
                style: { marginRight: '5px' },
                disabled: false //是否可用
            },
            badgeProps: {
                isExist: false
            },
            functions: {},
            loading: false
        };
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {对象工厂} objFct
     * @param {make类型} type
     */
    button_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }
        // var formItemProps = { style: {} }; //input外层属性
        // var inputprops = { style: {} }; //转换后属性
        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.inputprops, this.state.tooltiProps, this.state.badgeProps);
        //添加公共属性
        addCtnCommonAttribute(this, moduleDesc, this.state.inputprops)
        //绑定事件
        this.bindEvent(moduleDesc, this.state.inputprops, this.state.functions,type);
    }

    /**
     * 绑定事件
     * @param {*} moduleDesc 
     * @param {*} formProps 
     */
    bindEvent(moduleDesc, formProps, functions,type) {
        //拖拽模式 不生成事件
        if(type == 'dnd'){
            return;
        }
        var eck = moduleDesc.clkLsn; // 用户自定义点击事件
        if (eck) {
            var $eck = new Function("module", "objFct", eck);
            functions.onClick = $eck;
            formProps.onClick = SgiEventHandler.onClick.bind(this);
        }
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, inputprops, tooltiProps, badgeProps) {
        //csstyle 样式文件这个我还不知道怎么用
        var csstyle = moduleDesc.csstyle;
        if (csstyle == 'button-primary') {
            inputprops.type = 'primary'
        } else if (csstyle == 'button-auxiliary') {
            inputprops.type = 'dashed'
        } else if (csstyle == 'button-danger') {
            inputprops.type = 'danger'
        }

        //右上角标 ??未完全实现
        var badgeText = moduleDesc.badgeText;
        if (badgeText) {
            badgeProps.isExist = true;
            badgeProps.count = badgeText;
        }

        //显示边框 ??
        var isBrdr = moduleDesc.isBrdr;
        //边框宽度 ??未实现
        var bdrW = moduleDesc.bdrW;

        //背景图片 ??未实现
        var bkImgPh = moduleDesc.bkImgPh;

        //背景图重复方式 ??未实现
        var bkImgRptType = moduleDesc.bkImgPbkImgRptTypeh;

        var btnIconPh = moduleDesc.btnIconPh;//按钮图标
        if (btnIconPh) inputprops.icon = btnIconPh;

        //按钮图片位置 ??未实现,如果想控制 Icon 具体的位置，只能直接使用 Icon 组件，而非 icon 属性
        var iconAlg = moduleDesc.iconAlg;

        //按钮的提示信息
        var hvInfo = moduleDesc.hvInfo;
        if (hvInfo) {
            tooltiProps.title = hvInfo;
            tooltiProps.defaultVisible = false;
        } else {
            tooltiProps.defaultVisible = true;
        }

        //文本位置 ??
        var teAl = moduleDesc.teAl;

        //显示名称
        var te = Resource.getTRByPrm(moduleDesc).te;
        if (te) this.state.text = te;

        var isDis = moduleDesc.isDis; //是否可用
        if (isDis) {
            inputprops.disabled = true;
        } else {
            inputprops.disabled = false;
        }
    }

    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }


    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性
            this.button_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        return (
            <Tooltip {...this.state.tooltiProps}>
                {this.state.badgeProps.isExist ?
                    <Badge {...this.state.badgeProps}>
                        <Button {...this.state.inputprops}>
                            {this.state.text}
                        </Button>
                    </Badge>
                    :
                    <Button {...this.state.inputprops}>
                        {this.state.text}
                    </Button>
                }
            </Tooltip>
        );
    }
}

//给类添加公共方法
// Object.assign(SgiFormButton.prototype, sgiFormCtlBaseFun);

export { SgiButton };
