import React from 'react';
import ReactDOM from 'react-dom';
import { Tabs, Collapse } from 'antd';
import { addCtnCommonAttribute } from "./SgiCtnComm"
import { convertModuleByGuid } from "./SgiCompComm"
import { ObjFactory } from '../sgiFactory/ObjFactory'
const TabPane = Tabs.TabPane;
const Panel = Collapse.Panel;
import { SgiEventHandler } from './SgiEventHandler';
import { uuid } from "../sgiCommon/sgiCommon";
import { addCollapseCtlDndInfo } from '../sgiDndDev/sgiDndDevComFun'

class SgiCollapse extends React.Component {

    //这个暂时不好用 以后在处理
    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };

    constructor(props) {
        super(props);
        this.state = {
            itemPanelType: "cos",//区分是tab还是折叠面板的 普通面板整合tabpane和折叠panel
            collapseProps: { style: { height: "100%", width: "100%" } },//form属性
            collapseItems: [], //form下控件数组
            functions: {},
            loading: false
        };
    }

    /**
     * 根据描述创建form
     * @param {父组件} panelModule
     * @param {描述} moduleDesc
     * @param {对象工厂} objFct
     * @param {make类型} type
     */
    collapse_mk(panelModule, moduleDesc, objFct, type) {
        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }
        var collapseProps = { style: {} }; //form属性
        var collapseItems = []; //form下控件数组

        //转换基础属性
        this.AddAttribute(moduleDesc, this.state.collapseProps, this);
        //转换form公共属性
        addCtnCommonAttribute(this, moduleDesc, this.state.collapseProps);
        //设置布局
        //this.setFormCtlLayout(moduleDesc, formProps);
        //绑定事件
        this.bindEvent(panelModule, moduleDesc, this.state.collapseProps, this.state.functions, type);
        //组装form表单下的控件信息
        this.fitTabsItems(moduleDesc, this.state.collapseItems, objFct, type);
        //添加拖拽布局信息 根据type类型
        addCollapseCtlDndInfo(this, this.state.collapseItems, this.state.collapseProps, type);
    }

    /**
     * 绑定事件
     * @param {*} moduleDesc
     * @param {*} formProps
     */
    bindEvent(panelModule, moduleDesc, collapseProps, functions, type) {
        //拖拽模式 不生成事件
        console.log("panelModule", panelModule);
        var expandLsn = moduleDesc.epdLsn;// 面板的展开监听器
        // var collapseLsn = wvJson.clpLsn;// 面板的折叠监听器
        if (expandLsn && type != 'dnd') {
            var $expandLsn = new Function("module", "objFct", "key", expandLsn);
            functions.expandLsn = $expandLsn;
        }
        collapseProps.onChange = SgiEventHandler.expd.bind(this);
        // if (collapseLsn) {
        //     var $expandLsn = new Function("objFct", "ctn", collapseLsn);
        //     functions.collapseLsn = $collapseLsn;
        //     formProps.onChange = SgiEventHandler.clp.bind(this);
        // }
    }


    /**
     * 根据描述组装子对象
     * @param {描述信息} moduleDesc
     * @param {属性} formProps
     */
    fitTabsItems = function (moduleDesc, tabsItems, objFct, type) {
        var me = this;

        let cldSet = moduleDesc.cldSet;
        if (cldSet && cldSet.length && cldSet.length > 0) {
            let cosPane;
            cldSet.forEach((item, index) => {
                let { cId, te, isDis } = item;
                cosPane = { forceRender: true }; //默认全部加载
                if (!cId) {
                    cId = uuid(8);
                    item.cId = cId;
                }
                if (te) cosPane.header = te;
                if (cId) cosPane.key = cId;
                if (isDis) cosPane.disabled = isDis;
                tabsItems.push(<Panel {...cosPane}>{convertModuleByGuid(me, item, null, objFct, type)}</Panel>);
            });
        }
    }

    setActiveItem = (key) => {
        this.setState({ activeKey: key });
    }
    /**
     * 获取当前激活面板的组件标识
     * @return {[type]} [description]
     */
    getActiveItem = () => {
        return this.state.activeKey;
    }
    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }



    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            let { panelModule, moduleDesc, objFct, type } = this.props;
            //组装属性
            this.collapse_mk(panelModule, moduleDesc, objFct, type);
            this.loaded = true;
        }

        return (
            <Collapse {...this.state.collapseProps} activeKey={this.state.activeKey}>
                {this.state.collapseItems}
            </Collapse>
        )
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formProps
     */
    AddAttribute = function (moduleDesc, tabsProps, collp) {
        //初始化激活的面板
        let atvTab = moduleDesc.atvTab;
        if (atvTab) {
            tabsProps.defaultActiveKey = atvTab;
            collp.state.activeKey = tabsProps.defaultActiveKey;
        }

        tabsProps.accordion = true;//先默认这个 以后再去实现其他的属性
    }
}


export { SgiCollapse };
