/**
 * 所有组件的公共方法
 * wangz
 * 2018.3.9
 */
import React from 'react';
import ReactDOM from 'react-dom';
import { AllCompGUID } from "./SgiCompConstant";
import { SgiFormText } from "./SgiFormText";
import { SgiFormTextArea } from "./SgiFormTextArea";
import { SgiFormInputNumber } from "./SgiFormInputNumber"
import { SgiFormSelect } from './SgiFormSelect'
import { SgiFormRadio } from './SgiFormRadio'
import { SgiFormCheckboxGroup } from './SgiFormCheckboxGroup'
import { SgiFormCheckbox } from './SgiFormCheckbox'
import { SgiFormTimePicker } from './SgiFormTimePicker'
import { SgiFormDatePicker } from './SgiFormDatePicker'
import { SgiFormUpload } from './SgiFormUpload'
import { SgiButton } from './SgiButton'
import { SgiForm } from "./SgiForm";
import { SgiRow } from "../sgiLayout/SgiRow";
import { SgiCol } from "../sgiLayout/SgiCol";
import { SgiTabs } from "./SgiTabs";
import { SgiPanel } from "./SgiPanel";
import { SgiTable } from "./SgiTable";
import { SgiTree } from "./SgiTree";
import { SgiCard } from "./SgiCard";
import { SgiCollapse } from "./SgiCollapse";
import { SgiMainComp } from "./SgiMainComp";
import { uuid } from "../sgiCommon/sgiCommon";
import { ComponentManager } from '../sgiFactory/ComponentManager'
import { SgiTreeSelect } from "./SgiTreeSelect";
import { SgiToolbar } from "./SgiToolbar";
import { SgiFormInputSearch } from "./SgiFormInputSearch";
import { SgiNest } from "./SgiNest";
import { SgiMenu } from "./SgiMenu";
import { SgiSteps } from "./SgiSteps";
import { SgiSplitter } from './SgiSplitter';
import { SgiIcon } from './SgiIcon';

/**
* 根据类型转换为指定控件
* @param {描述信息} moduleDesc
* @param {属性} formProps
*/
var convertModuleByGuid = function (currentModule, moduleDesc, bdInst, objFct, type) {

    var mdType = moduleDesc.desId;
    var cId = moduleDesc.cId;
    let module;
    if (mdType === AllCompGUID.UCV) { //主main
        if (!cId) cId = "mainUcv_" + uuid(8);
        module = <SgiMainComp ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.WV) {//form
        if (!cId) cId = "form_" + uuid(8);
        module = <SgiForm ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.SPLITTER) {//分割窗
        if (!cId) cId = "spliter_" + uuid(8);
        module = <SgiSplitter ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TAB) {//tab
        if (!cId) cId = "tab_" + uuid(8);
        module = <SgiTabs ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.CARD) { //card
        if (!cId) cId = "card_" + uuid(8);
        module = <SgiCard ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.ACCORDION) { //折叠面板
        if (!cId) cId = "collapse_" + uuid(8);
        module = <SgiCollapse ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.FIELDSET) { //组控件

    } else if (mdType === AllCompGUID.PANEL) { //普通面板
        if (!cId) cId = "panel_" + uuid(8);
        module = <SgiPanel ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.NEST) {//嵌入面板
        if (!cId) cId = "nest_" + uuid(8);
        module = <SgiNest ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TPL) { //模板

    } else if (mdType === AllCompGUID.CONTAINER) {//自定义面板

    } else if (mdType === AllCompGUID.DVPANEL) {//DVPANEL

    } else if (mdType === AllCompGUID.DU) {

    } else if (mdType === AllCompGUID.FLOATWINDOW) { //浮动面板

    } else if (mdType === AllCompGUID.MENU) {//菜单
        if (!cId) cId = "menu_" + uuid(8);
        module = <SgiMenu ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    }
    /**
     * 创建基本控件
     * 创建方法 创建物理控件。
     */
    else if (mdType === AllCompGUID.FIELDTEXT) { //文本框
        if (!cId) cId = "text_" + uuid(8);
        module = <SgiFormText ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.NUMBER) { //数字控件
        if (!cId) cId = "num_" + uuid(8);
        module = <SgiFormInputNumber ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.COMBOBOX) { //下拉框
        if (!cId) cId = "select_" + uuid(8);
        module = <SgiFormSelect ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.COMBOXTREE) {//下拉树
        if (!cId) cId = "treeselect_" + uuid(8);
        module = <SgiTreeSelect ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.COMBOXGRID) {//下拉表格

    } else if (mdType === AllCompGUID.RADIOGROUP) {//单选框
        if (!cId) cId = "radio_" + uuid(8);
        module = <SgiFormRadio ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.CHECKBOXGROUP) {//多选框
        if (!cId) cId = "ck_" + uuid(8);
        module = <SgiFormCheckboxGroup ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TIME) {//时间
        if (!cId) cId = "time_" + uuid(8);
        module = <SgiFormTimePicker ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.DATE) {//日期
        if (!cId) cId = "date_" + uuid(8);
        module = <SgiFormDatePicker ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.FILE) {//文件
        if (!cId) cId = "file_" + uuid(8);
        module = <SgiFormUpload ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.UPLOADFILE) {//上传
        if (!cId) cId = "file_" + uuid(8);
        module = <SgiFormUpload ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TEXTAREA) {//文本域
        if (!cId) cId = "txta_" + uuid(8);
        module = <SgiFormTextArea ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.EDITORAREA) {//富文本

    } else if (mdType === AllCompGUID.BUTTON) {//按钮
        if (!cId) cId = "btn_" + uuid(8);
        module = <SgiButton ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.CHECKBOX) {//checkbox
        if (!cId) cId = "ck_" + uuid(8);
        module = <SgiFormCheckbox ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.COLOR) {

    } else if (mdType === AllCompGUID.FONT) {

    } else if (mdType === AllCompGUID.PASSWORD) {//密码

    } else if (mdType === AllCompGUID.MONETARYTEXT) {  //金额控件

    } else if (mdType === AllCompGUID.TOOLBAR) {  //工具条
        if (!cId) cId = "toba_" + uuid(8);
        module = <SgiToolbar ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TBFILL) {  //工具条占位符

    } else if (mdType === AllCompGUID.POPUI) {  //弹出窗
        if (!cId) cId = "popui_" + uuid(8);
        module = <SgiFormInputSearch ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.EDITOR) {  //弹出窗

    } else if (mdType === AllCompGUID.TREE) {
        if (!cId) cId = "tree_" + uuid(8);
        module = <SgiTree ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.TABLE) {
        if (!cId) cId = "table_" + uuid(8);
        module = <SgiTable ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.LINE) { //折线图

    } else if (mdType === AllCompGUID.AREA) { //面积图

    } else if (mdType === AllCompGUID.BAR) { //条形图

    } else if (mdType === AllCompGUID.SCATTER) { //散点图

    } else if (mdType === AllCompGUID.PIE) { //饼图

    } else if (mdType === AllCompGUID.GAUGE) { //表盘图

    } else if (mdType === AllCompGUID.RADAR) { //雷达图

    } else if (mdType === AllCompGUID.PROGRESSBAR) { //进度条

    } else if (mdType === AllCompGUID.IMG) { //图片控件

    } else if (mdType === AllCompGUID.ICON) { //图标
        if (!cId) cId = "icon_" + uuid(8);
        module = <SgiIcon ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.LABEL) { //标签控件

    } else if (mdType === AllCompGUID.FIELDDISPLAY) { //只读文本控件

    } else if (mdType === AllCompGUID.COMPONENT) { //自定义标签

    } else if (mdType === AllCompGUID.STATBUTTON) { //状态按钮

    } else if (mdType === AllCompGUID.STEP) { //步骤控件
        if (!cId) cId = "steps_" + uuid(8);
        module = <SgiSteps ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.MONETARY2TEXT) {  //金额控件

    } else if (mdType === AllCompGUID.PASSWORDSTRENGTH) {  //密码强度控件//增加密码强度控件20170928-wangj

    } else if (mdType === AllCompGUID.ITEM) {  //

    } else if (mdType === AllCompGUID.DIVCOMBOBOX) {  //自定义下拉窗

    }
    //创建布局
    else if (mdType === AllCompGUID.LT_ROW) { //文本框
        if (!cId) cId = "ltrow_" + uuid(8);
        module = <SgiRow ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    } else if (mdType === AllCompGUID.LT_COL) { //数字控件
        if (!cId) cId = "ltcol_" + uuid(8);
        module = <SgiCol ref={cId} panelModule={currentModule}
            moduleDesc={moduleDesc} bdInst={bdInst} objFct={objFct} type={type} />
    }
    // ComponentManager.set(uid, cId, module);
    return module;
}

let refFunction = function (ctl) {

    if (!ctl) {
        return;
    }
    console.log("refFunction", ctl.props.moduleDesc.cId);
    console.log("refFunction", ctl.props.moduleDesc.desId);
    let { moduleDesc, objFct } = ctl.props;
    let itemKey = moduleDesc.cId;
    if (!itemKey) {
        return;
    }
    ComponentManager.set(objFct.getUID(), moduleDesc.cId, ctl);
}

let refModalFunction = function (ctl) {

    if (!ctl) {
        return;
    }
    let { moduleDesc, objFct } = ctl.props;
    let mainComp = ComponentManager.get(objFct.getUID(), objFct.getUID());
    mainComp.setModal(ctl);
}

export { convertModuleByGuid, refFunction, refModalFunction };
