import React from 'react';
import ReactDOM from 'react-dom';
import { Input } from 'antd';

class SgiDemo extends React.Component {

    static defaultProps = {
        autoPlay: false,
        maxLoops: 10,
    };  // 注意这里有分号
    static propTypes = {
        autoPlay: React.PropTypes.bool.isRequired,
        maxLoops: React.PropTypes.number.isRequired,
        posterFrameSrc: React.PropTypes.string.isRequired,
        videoSrc: React.PropTypes.string.isRequired,
    };  // 注意这里有分号

    constructor(props){
        super(props);
        this.state = {
            loopsRemaining: this.props.maxLoops,
        };
    }

    //render之前调用，业务逻辑都应该放在这里，如对state的操作等
    componentWillMount = function () {
        console.log("componentWillMount");
    }

    //渲染并返回一个虚拟DOM
    render = function () {
        console.log("render");
        return (
            <div> hello <strong> {this.props.name} </strong></div>
        );
    }

    //该方法发生在render方法之后。在该方法中，ReactJS会使用render生成返回的虚拟DOM对象来创建真实的DOM结构
    componentDidMount = function () {
        console.log("componentDidMount");
    }

    //3.更新阶段
    componentWillReceiveProps = function () {
        console.log("componentWillReceiveProps");
    }

    //是否需要更新
    shouldComponentUpdate = function () {
        console.log("shouldComponentUpdate");
        return true;
    }

    //将要更新
    componentWillUpdate = function () {
        console.log("componentWillUpdate");
    }

    //更新完毕
    componentDidUpdate = function () {
        console.log("componentDidUpdate");
    }

    //4.销毁阶段
    componentWillUnmount = function () {
        console.log("componentWillUnmount");
    }
}

export {SgiDemo};