import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input, Cascader } from 'antd';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
const FormItem = Form.Item;

import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import { StandardCode } from '../sgiCommon/StandardCode';
// const store = [{
//     value: 'zhejiang',
//     label: '浙江',
//     children: [{
//       value: 'hangzhou',
//       label: '杭州',
//       children: [{
//         value: 'xihu',
//         label: '西湖',
//       }],
//     }],
//   }, {
//     value: 'jiangsu',
//     label: '江苏',
//     children: [{
//       value: 'nanjing',
//       label: '南京',
//       children: [{
//         value: 'zhonghuamen',
//         label: '中华门',
//       }],
//     }],
//   }];

class SgiFormCascader extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
        this.state.displayField = '';
        this.state.saveField = '';
        this.state.casData = []; //下拉框内容
        this.state.childrenName = "cldSet";
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule 
     * @param {组件描述} moduleDesc 
     * @param {绑定实例ID} bdInst 
     * @param {当前工作区} ws 
     * @param {make类型} type 
     */
    cascader_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        var moduleDesc = this.props.moduleDesc;
        if (!moduleDesc) {
            return;
        }
        //组装下拉框内容
        var casStore = this.fitSelectOption(moduleDesc);
        this.state.casData = casStore;
        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);

        // console.log(formItemProps);
        //console.log(selectprops);

        // this.formItemProps = formItemProps;
        // this.selectprops = selectprops;
        // this.c = moduleDesc.c;   
        //this.store = moduleDesc.store;    // 数据源  
    }
    /**
   * 组装下拉框内容
   * @param {描述} moduleDesc 
   */
    fitSelectOption(moduleDesc) {

        // this.state.store = [];
        var tData;
        var scId = moduleDesc.scId; //绑定实例名
        if (scId) {
            // 下拉窗列表值在标准代码中的id
            tData = StandardCode.getSC(scId);
            this.state.displayField = 'te';
            this.state.saveField = 'c';
        } else {
            var insName = moduleDesc.insName; //绑定实例名

            //取得绑定类名`  var tData = [];
            if (insName) {
                tData = objFct.get(insName);
            }
            this.state.displayField = moduleDesc.showKey;
            this.state.saveField = moduleDesc.saveKey;
        }
        if (!tData) {
            return [];
        }
        return tData;











        // if(!moduleDesc.scId){
        //     return;
        // }
        // //参数工厂获取标准代码 暂时当获取到了 属性为'sc', 'te', 'c'
        // // 下拉窗列表值在标准代码中的id
        // var comboBoxData = StandardCode.getSC(moduleDesc.scId);
        // if (!comboBoxData) {
        //     return;
        // }
        // let scList = [];
        // var size = comboBoxData.length;
        // if(!size == 0){
        //     for (let i = 0; i < size; i++) {
        //         var item = comboBoxData[i];
        //          scList.push({ te: (item.te), c: (item.c) });
        //     }

        //     let { scId, useCodes } = moduleDesc;
        //     if (!scId) {
        //         return;
        //     }
        //     scList.forEach((item, index) => {
        //         this.state.store.push(<Option key={item.c}>{item.te}</Option>);
        //     })
        // }    

    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc 
     * @param {属性} formItem 
     * @param {属性} inputprops 
     */
    AddInputAttribute(moduleDesc, formItemProps, inputprops) {
        //csstyle 样式文件?这个我还不知道怎么用
        // var csstyle = moduleDesc.csstyle;

        //是否是密码控件 这个暂时不用
        // var isPwd = moduleDesc.isPwd;
        // 数据源

        //当下拉列表为空时显示的内容    
        if (this.state.casData.length < 1) {
            var emptyText = moduleDesc.emptyText;
            inputprops.placeholder = emptyText;
        }
        //次级菜单的展开方式，可选 'click' 和 'hover'
        var expend = moduleDesc.expandTrigger;
        inputprops.expandTrigger = expend;
        //是否支持清除
        inputprops.allowClear = moduleDesc.allowClear;

        // if(store&&store.length>0){
        // var i = moduleDesc.dVal;
        // selectprops.defaultValue ={store[i].value,store[i].children[i].value,};
        // }


        //选择即改变
        var chgOnsel = moduleDesc.chgOnsel;
        if (chgOnsel) inputprops.changeOnSelect = 'changeOnSelect ';
        //是否显示搜索框
        var search = moduleDesc.showSearch;
        if (search) inputprops.showSearch = search;




    }
    fitCasNodes1(comboBoxData) {
        var items;
        let scList = [];
        let childrenName = this.state.childrenName;
        var size = comboBoxData.length;
        for (let i = 0; i < size; i++) {
            var item = comboBoxData[i];
            if (item[childrenName] && item[childrenName].length) {
                items = this.fitCasNodes2(item[childrenName]);
                scList.push({ label: (item[this.state.displayField]), value: (item[this.state.saveField]), children: (items) });
            }
            scList.push({ label: (item[this.state.displayField]), value: (item[this.state.saveField]) });
        }
        return scList;
    };

    fitCasNodes2(comboBoxData) {
        var items;
        let scList = [];
        let childrenName = this.state.childrenName;
        var size = comboBoxData.length;
        for (let i = 0; i < size; i++) {
            var item = comboBoxData[i];
            if (item[childrenName] && item[childrenName].length) {
                items = this.fitCasNodes2(item[childrenName]);
                scList.push({ label: (item[this.state.displayField]), value: (item[this.state.saveField]), children: (items) });
            }
            scList.push({ label: (item[this.state.displayField]), value: (item[this.state.saveField]) });
        }
        return scList;
    };

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性
            this.cascader_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        let value = this.state.inputprops.value;
        var newcomboBoxData = [];
        if (value) {
            var valueList = value.split(",");//拆分
            for (var i = 0; i < valueList.length; i++) {
                var uceC = valueList[i];
                newcomboBoxData.push(uceC);
            }
            this.state.showValue = newcomboBoxData;

        } else {
            this.state.showValue = value;
        }
        return (
            <FormItem {...this.state.formItemProps}>
                <Cascader   {...this.state.inputprops} value={this.state.showValue} options={this.fitCasNodes1(this.state.casData)} />
            </FormItem>
        );
    }
}
//给类添加公共方法
Object.assign(SgiFormCascader.prototype, sgiFormCtlBaseFun);
export { SgiFormCascader };