import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input, Checkbox } from 'antd';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
const FormItem = Form.Item;
const CheckboxGroup = Checkbox.Group;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import { StandardCode } from '../sgiCommon/StandardCode';



class SgiFormCheckboxGroup extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
        this.state.store = [];
        this.state.checked = "";
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    checkbox_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        var moduleDesc = this.props.moduleDesc;
        if (!moduleDesc) {
            return;
        }
        //组装下拉框内容
        this.fitSelectOption(moduleDesc);
        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
        this.state.chkAll = moduleDesc.chkAll;
    }

    /**
     * 组装下拉框内容
     * @param {描述} moduleDesc
     */
    fitSelectOption(moduleDesc) {

        this.state.store = [];

        let { scId, useCodes } = moduleDesc;
        if (!scId) {
            return;
        }
        // 下拉窗列表值在标准代码中的id
        var comboBoxData = StandardCode.getSC(moduleDesc.scId);
        if (!comboBoxData) {
            return;
        }
        let scList = [];
        var size = comboBoxData.length;
        if (!size == 0) {
            for (let i = 0; i < size; i++) {
                var item = comboBoxData[i];
                scList.push({ te: (item.te), c: (item.c) });
            }

            let { scId, useCodes } = moduleDesc;
            if (!scId) {
                return;
            }
            scList.forEach((item, index) => {
                this.state.store.push(<Checkbox value={item.c}>{item.te}</Checkbox>);
            })
        }



        //参数工厂获取标准代码 暂时当获取到了 属性为'sc', 'te', 'c'
        //下面是临时数据
        // let scList = [];
        // for (let i = 1; i < 5; i++) {
        //     scList.push({ te: (i.toString(2)), c: (i.toString(2)) });
        // }

        // if (!scList || scList.length < 1) {
        //     return;
        // }

        // scList.forEach((item, index) => {
        //     this.state.store.push(<Checkbox value={item.c}>{item.te}</Checkbox>);
        // })
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        //	初始是否选中
        //var deChekd = moduleDesc.deChekd;
        //if(deChekd)inputprops.defaultChecked = deChekd;
        //是否显示按钮样式
        //设置默认选中
        var checked = moduleDesc.checked;
        if (checked) this.state.inputprops.value = checked;
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.checkbox_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        let value = this.state.inputprops.value;
        var newcomboBoxData = [];
        if (value) {
            var valueList = value;//value就是个数组//.split(",");//拆分
            for (var i = 0; i < valueList.length; i++) {
                var uceC = valueList[i];
                newcomboBoxData.push(uceC);
            }
            this.state.showValue = newcomboBoxData;

        } else {
            this.state.showValue = value;
        }

        return (
            <FormItem {...this.state.formItemProps}>
                <CheckboxGroup  {...this.state.inputprops} value={this.state.showValue}> {this.state.store}</CheckboxGroup>
            </FormItem>
        );

    }
}
//给类添加公共方法
Object.assign(SgiFormCheckboxGroup.prototype, sgiFormCtlBaseFun);
export { SgiFormCheckboxGroup };
