/**
 * 表单控件的基础方法，供控件继承
 * wangz
 * 2018.3.12
 */

"use strict"
import { sgiFormCtlCheck } from "./sgiFormCtlValidator"

var sgiFormCtlBaseFun = {

    /**
     * 初始化state属性
     */
    initState: function () {
        //初始化state
        this.state = {
            validRules: {},
            validState: true,
            loading: false,
            formItemProps: {
                style: { 'margin-bottom': "1px", 'margin-top': "1px" },
                hasFeedback: false,
                help: undefined,
                validateStatus: 'success',
                colon: false //不显示：
            }, //存放formItem属性
            inputprops: {
                style: { width: "100%" },
                // value: undefined,  //文本框显示值 //2018.04.27-yly,有value会导致默认值无法赋值
                disabled: false, //是否可用
            },//存放input属性
            functions: {} //存放事件函数
        };
    },

    /**
    * 设置value值
    */
    setValue: function (value) {
        //更新state
        if (value === this.state.inputprops.value) {
            return;
        }
        this.state.inputprops.value = value;
        //页面校验
        this.validate(value);
    },

    /**
     * 设置是否禁用
     */
    setDisabled: function (value) {
        this.state.inputprops.disabled = value;
        this.setState(this.state.inputprops);
    },

    /**
    * 设置是否隐藏
    */
    setHidden: function (value) {
        // this.state.inputprops.hidden = value; //2018.04.25-yly,修改弹窗无法隐藏问题
        // this.setState(this.state.inputprops);
        if (value) {
            this.state.formItemProps.style.display = "none"
        } else {
            this.state.formItemProps.style.display = undefined;
        }
        this.setState(this.state.formItemProps);
    },
    ctlRefresh: function (attname, bdInst, objFct, value) {
        //对象工厂的值刷新
        if (bdInst && attname) {
            let bdInstData = objFct.get(bdInst);
            bdInstData[attname] = value;
        }

        //更新state
        this.state.inputprops.value = value;

        //页面校验
        this.validate(value);
    },

    // 检查数据合法性
    validate: function (value) {
        if (!value) {
            value = this.state.inputprops.value;
        }
        var validRules = this.state.validRules;
        if (validRules.length === 0) {
            this.setSuccess();
            return true;
        }

        //var flag = true;
        var msg = sgiFormCtlCheck(validRules, value);
        if (msg !== '') {
            this.setError(msg);
            //lag = false;
        } else {
            this.setSuccess();
        }
        return msg;
    },
    setError: function (msg) {
        this.state.formItemProps.hasFeedback = true;
        this.state.formItemProps.help = msg;
        this.state.formItemProps.validateStatus = 'error';
        this.setState(this.state.formItemProps);
    },
    setSuccess: function () {
        this.state.formItemProps.hasFeedback = false;
        this.state.formItemProps.help = undefined;
        this.state.formItemProps.validateStatus = 'success';
        this.setState(this.state.formItemProps);
    },
    refresh: function () {
        this.loaded = false;
        this.setState({ loading: false });
    }
}
export { sgiFormCtlBaseFun }
