/**
 * 表单控件的maker的公共方法
 * wangz
 * 2018.3.9
 */

"use strict"
import React from 'react';
import ReactDOM from 'react-dom';
import { message } from 'antd';
import { Resource } from '../sgiCommon/Resource';
import { SgiEventHandler } from './SgiEventHandler';

/**
 * 绑定显示值
 * @param {描述信息} currentModule
 * @param {描述信息} moduleDesc
 * @param {数据} bdInst
 * @param {对象工厂} objFct
 * @param {属性} formItem
 * @param {属性} inputprops
 */
var bindValue = function (currentModule, moduleDesc, bdInst, objFct, formItem, inputprops) {

    if (!moduleDesc.c) {
        return;
    }

    //currentModule.bdInst = bdInst;
    var attname = moduleDesc.c;
    currentModule.state.attname = attname;

    if (!bdInst || !objFct) {
        return;
    }

    var bdInstValue = objFct.get(bdInst);
    if (bdInstValue[attname]) {//2018.04.27-yly,有value会导致默认值无法赋值
        inputprops.value = bdInstValue[attname];
    }
}

/**
 * 属性转换
 * @param {描述信息} currentModule
 * @param {描述信息} moduleDesc
 * @param {属性} formItem
 * @param {属性} inputprops
 */
var AddFormCtlCommonAttribute = function (currentModule, moduleDesc, formItem, inputprops) {

    var cId = moduleDesc.cId; //cid 唯一标示
    if (cId) inputprops.id = cId;

    var isDis = moduleDesc.isDis; //是否可用
    inputprops.disabled = isDis;
    // if (isDis) {
    //     inputprops.disabled = isDis;
    // } else {
    //     inputprops.disabled = isDis;
    // }

    var text = Resource.getTRByPrm(moduleDesc).te; //设置标签
    if (text) formItem.label = text;

    var ctlW = moduleDesc.ctlW; //控件宽度
    // if (ctlW) formItem.style.width = ctlW;

    var ctlH = moduleDesc.ctlH; //控件高度
    if (ctlH) {
        formItem.style.height = ctlH;
        inputprops.style.height = ctlH;//输入框也随着高度变动
    } else {
        formItem.style.height = undefined;//编辑的时候即时刷新，也可以不加
        inputprops.style.height = undefined;//编辑的时候即时刷新，也可以不加
    }

    var lblW = moduleDesc.lblW; //设置标签宽度

    if (ctlW && lblW) {
        var lblWSpan = parseInt(lblW / ctlW * 24)
        var wrapperSpan = 24 - lblWSpan;
        formItem.labelCol = { span: lblWSpan }
        formItem.wrapperCol = { span: wrapperSpan }
    } else {
        formItem.labelCol = { span: 6 }
        formItem.wrapperCol = { span: 18 }
    }

    var isLbl = moduleDesc.isLbl; //设置是否隐藏标签
    if (isLbl) {
        formItem.label = undefined;
        formItem.labelCol = { span: 0 }
        formItem.wrapperCol = { span: 24 }
    }

    var inpPopTe = moduleDesc.inpPopTe; //提示内容
    if (inpPopTe) inputprops.placeholder = inpPopTe;

    var defVal10 = moduleDesc.defVal10; //默认内容
    if (defVal10) inputprops.defaultValue = defVal10;

    var bdText = moduleDesc.bdText; //后置内容
    if (bdText) inputprops.addonAfter = bdText;

    var alwBlk = moduleDesc.alwBlk; //是否允许为空
    formItem.required = !alwBlk;
    currentModule.state.validRules.required = !alwBlk;
    // if (!alwBlk) {
    //     formItem.required = !alwBlk;
    //     currentModule.state.validRules.required = !alwBlk;
    // } else {
    //     formItem.required = !alwBlk;
    //     currentModule.state.validRules.required = !alwBlk;
    // }

    var maxL = moduleDesc.maxL; //设置字段输入的最大长度
    if (maxL) currentModule.state.validRules.maxL = maxL;
    else currentModule.state.validRules.maxL = undefined;
    var minL = moduleDesc.minL; //设置字段输入的最小长度
    if (minL) currentModule.state.validRules.minL = minL;
    else currentModule.state.validRules.minL = undefined;

    var isHdn = moduleDesc.isHdn; //是否隐藏
    if (isHdn) {
        formItem.style.display = "none"
    } else {
        formItem.style.display = undefined;
    }


    var lblAlg = moduleDesc.lblAlg; //设置标签对齐方式??没实现
    var isClp = moduleDesc.isClp; //设置是否根据内容字段进行伸展和收缩??没实现
    var msfTgt = moduleDesc.msfTgt; //设置错误信息提示位置??没实现

    // var prefix = moduleDesc.prefix;//前缀图
    // if (prefix) inputprops.prefix = prefix;
}

/**
 * 设置布局
 * @param {描述信息} moduleDesc
 * @param {属性} formItem
 * @param {属性} inputprops
 */
var setFormCtlLayout = function (moduleDesc, formItem, inputprops) {


}


/**
 * 事件转换
 * @param {描述信息} currentModule
 * @param {描述信息} moduleDesc
 * @param {对象工厂} objFct
 * @param {属性} inputprops
 */
var bindEvent = function (currentModule, moduleDesc, objFct, inputprops, functions, type) {

    //拖拽模式 不生成事件
    if (type == 'dnd') {
        return;
    }

    //onchange
    var chgLsn = moduleDesc.chgLsn; // 用户自定义点击事件
    if (chgLsn) {
        var $chgLsn = new Function("module", "objFct", 'nv', 'record', chgLsn);
        functions.onChange = $chgLsn;
    }
    inputprops.onChange = SgiEventHandler.onChange.bind(this, currentModule);

    //onFocus
    var inLsn = moduleDesc.inLsn; // 用户自定义点击事件
    if (inLsn) {
        var $inLsn = new Function("module", "objFct", inLsn);
        functions.onFocus = $inLsn;
        inputprops.onFocus = SgiEventHandler.onFocus.bind(this, currentModule);
    }

    //onBlur
    var lveLsn = moduleDesc.lveLsn; // 用户自定义点击事件
    if (lveLsn) {
        var $lveLsn = new Function("module", "objFct", lveLsn);
        // functions.onInput = $lveLsn;//onInput???
        functions.onBlur = $lveLsn;
        inputprops.onBlur = SgiEventHandler.onBlur.bind(this, currentModule);
    }

    // //onInput
    // inputprops.onInput = function() {
    //     message.info('获取焦点事件');
    // }
    // //点击事件
    // inputprops.onClick = function () {
    //     message.info('点击事件');
    // }
    // //双击事件
    // inputprops.onDoubleClick = function () {
    //     message.info('双击事件');
    // }
    // //onCopy
    // inputprops.onCopy = function () {
    //     message.info('复制事件');
    // }
    // //onCut
    // inputprops.onCut = function () {
    //     message.info('剪切事件');
    // }
    // //onPaste
    // inputprops.onPaste = function () {
    //     message.info('粘贴事件');
    // }
}
export { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute };
