import React from 'react';
import ReactDOM from 'react-dom';
import { Form, DatePicker } from 'antd';
const FormItem = Form.Item;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm';
import moment from 'moment';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun";

class SgiFormDatePicker extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
        this.state.showValue = undefined; //展示的值
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    datePicker_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
    }


    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        var dateFmt = moduleDesc.dateFmt; //日期格式
        var dateTimeFlag = moduleDesc.dateTimeFlag; //是否显示时间

        if (dateFmt) {
            if (dateTimeFlag) {
                //showTime：增加时间选择功能，必须使用format添加时间
                inputprops.showTime = dateTimeFlag;
                inputprops.format = 'YYYY-MM-DD HH:mm:ss';
            } else {
                inputprops.format = dateFmt;
            }
        } else {
            if (dateTimeFlag) {
                //showTime：增加时间选择功能，必须使用format添加时间
                inputprops.showTime = dateTimeFlag;
                inputprops.format = 'YYYY-MM-DD HH:mm:ss';
            } else {
                inputprops.format = 'YYYY-MM-DD';
            }

        }

        //禁止选择星期 ??未实现
        var disDays = moduleDesc.disDays; //禁止选择星期

        //校验类型 ??未实现
        var vldC = moduleDesc.vldC;

        //csstyle 样式文件?这个我还不知道怎么用
        var csstyle = moduleDesc.csstyle;
    }
    /**
     * 设置不可选择的日期
     * @param  {[String]} format  [日期格式]
     * @param  {[String]} optBDt  [可选的起始日期]
     * @param  {[String]} optEDt  [可选的结束日期]
     * @param  {[type]} current [description]
     * @return {[type]}         [不可选择的日期]
     */
    disabledDate(format, optBDt, optEDt, current) {
        if (optBDt && !optEDt) {
            return current < moment(optBDt, format);
        }else if (!optBDt && optEDt) {
            return current > moment(optEDt, format).endOf('day');
        }else if (optBDt && optEDt) {
            return current < moment(optBDt, format) || current > moment(optEDt, format).endOf('day');
        }else{
            return null;
        }
    }

    //渲染并返回一个虚拟DOM
    render = function () {
        var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
        if (!this.loaded) {
            // var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.datePicker_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        //日期格式转换  value值转换成日期格式数据
        let value = this.state.inputprops.value;
        let format = this.state.inputprops.format;
        if (value) {
            this.state.showValue = moment(value, format);
        }
        let defaultValue = this.state.inputprops.defaultValue;
        if (defaultValue) {
            this.state.inputprops.defaultValue = moment(defaultValue, format);
        }
        // 可选的始末日期
        var optBDt = moduleDesc.optBDt; // 可选的起始日期
        var optEDt = moduleDesc.optEDt; // 可选的结束日期
        return (
            <FormItem {...this.state.formItemProps} >
                <DatePicker {...this.state.inputprops} value={this.state.showValue}
                    disabledDate={this.disabledDate.bind(this,format,optBDt,optEDt)}/>
            </FormItem>
        );
    }
}

//给类添加公共方法
Object.assign(SgiFormDatePicker.prototype, sgiFormCtlBaseFun);

export { SgiFormDatePicker };
