import React from 'react';
import ReactDOM from 'react-dom';
import { Form, InputNumber } from 'antd';
const FormItem = Form.Item;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun";

class SgiFormInputNumber extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    inputNumber_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
    }


    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        var maxV = moduleDesc.maxV; //输入最大值
        if (maxV) inputprops.max = maxV;

        var minV = moduleDesc.minV; //输入最小值
        if (minV) inputprops.min = minV;

        var step = moduleDesc.step; //微调的数字间距，value 的精度由 step 的小数位数决定。
        if (step) inputprops.step = step;

        var dcmDgt = moduleDesc.dcmDgt; // 小数位>step
        if (dcmDgt) inputprops.precision = dcmDgt;

        var intDgt = moduleDesc.intDgt; //整数位

        // 是否隐藏微调，控件本身微调就是隐藏的，鼠标悬浮时微调显示
        var isHdnTg = moduleDesc.isHdnTg;

        //csstyle 样式文件?这个我还不知道怎么用
        var csstyle = moduleDesc.csstyle;
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.inputNumber_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        return (
            <FormItem {...this.state.formItemProps}>
                <InputNumber {...this.state.inputprops} />
            </FormItem>
        );
    }
}

//给类添加公共方法
Object.assign(SgiFormInputNumber.prototype, sgiFormCtlBaseFun);

export { SgiFormInputNumber };
