import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input, Modal } from 'antd';
const FormItem = Form.Item;
import { /*bindValue,*/ bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
import { PrmFactory } from '../sgiFactory/PrmFactory'
const Search = Input.Search;
import { Resource } from '../sgiCommon/Resource';
import { SgiEventHandler } from './SgiEventHandler'
class SgiFormInputSearch extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);
        //初始化state属性
        this.initState();
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {对象工厂} objFct
     * @param {make类型} type
     */
    inputSearch_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops, objFct);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        this.bindValue(moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        this.bindEvent(moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, objFct);
    }

    bindValue(moduleDesc, bdInst, objFct, formItem, inputprops) {
        if (!bdInst || !moduleDesc.c || !objFct) {
            return;
        }
        //currentModule.bdInst = bdInst;
        var attname = moduleDesc.c;
        this.state.attname = attname;

        // var bdInstValue = objFct.get(bdInst);
        // inputprops.value = "显示值";//bdInstValue[attname];
    }

    /**
     * 绑定事件
     * @param  {[type]} moduleDesc    [description]
     * @param  {[type]} formItemProps [description]
     * @param  {[type]} inputprops    [description]
     * @param  {[type]} functions     [description]
     * @param  {[type]} objFct        [description]
     * @return {[type]}               [description]
     */
    bindEvent(moduleDesc, formItemProps, inputprops, functions, objFct) {
        var isCustom = moduleDesc.isCustom;//true:自定义
        var uid = moduleDesc.uid;
        if (!isCustom) {//非自定义
            moduleDesc.clkLsn = `tool.popUI("${uid}", objFct);`;
        }
        var iCLsn = moduleDesc.clkLsn; // 用户自定义点击事件
        if (iCLsn) {
            var $iCLsn = new Function("module", "objFct", "value", iCLsn);
            functions.onSearch = $iCLsn;
        }
        inputprops.onSearch = SgiEventHandler.onSearch.bind(this);
    }


    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops, objFct) {
        // var isCustom = moduleDesc.isCustom;//true:自定义
        // var clkLsn = moduleDesc.clkLsn;//点击事件
        // var uid = moduleDesc.uid;
        // if(isCustom && clkLsn){
        //   inputprops.onSearch = (value) => {
        //     eval(clkLsn);
        //   }
        // }else if (!isCustom) {
        //   inputprops.onSearch = (value) => {
        //     window.tool.popUIByUid(uid, objFct);
        //   }
        // }
    }


    //渲染并返回一个虚拟
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.inputSearch_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        return (
            <FormItem {...this.state.formItemProps}>
                <Search {...this.state.inputprops} />
            </FormItem>
        );
    }
}

//给类添加公共方法
Object.assign(SgiFormInputSearch.prototype, sgiFormCtlBaseFun);

export { SgiFormInputSearch };
