import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input, Select } from 'antd';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
const FormItem = Form.Item;
const Option = Select.Option;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import { StandardCode } from '../sgiCommon/StandardCode';
// const store = [];
// for (let i = 10; i < 36; i++) {
//     store.push(<Option key={i.toString(36) + i}>{i.toString(36) + i}</Option>);
// }

class SgiFormSelect extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
        this.state.store = []; //下拉框内容
        this.state.showValue = undefined; //展示的值
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    select_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        var moduleDesc = this.props.moduleDesc;
        if (!moduleDesc) {
            return;
        }
        //组装下拉框内容
        this.fitSelectOption(moduleDesc);
        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
    }

    /**
     * 组装下拉框内容
     * @param {描述} moduleDesc
     */
    fitSelectOption(moduleDesc) {

        this.state.store = [];

        // 下拉窗列表值在标准代码中的id
        var comboBoxData = StandardCode.getSC(moduleDesc.scId);
        if (!comboBoxData) {
            return;
        }

        let scList = [];
        var size = comboBoxData.length;
        if (!size == 0) {
            for (let i = 0; i < size; i++) {
                var item = comboBoxData[i];
                scList.push({ te: (item.te), c: (item.c) });
            }

            let { scId, useCodes } = moduleDesc;
            if (!scId) {
                return;
            }
            scList.forEach((item, index) => {
                this.state.store.push(<Option key={item.c}>{item.te}</Option>);
            })
        }
        //参数工厂获取标准代码 暂时当获取到了 属性为'sc', 'te', 'c'
        //下面是临时数据
        // let scList = [];
        // for (let i = 10; i < 36; i++) {
        //     scList.push({ te: (i.toString(36) + i), c: (i.toString(36) + i) });
        // }

        // if (!scList || scList.length < 1) {
        //     return;
        // }

    }
    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        //csstyle 样式文件?这个我还不知道怎么用
        // var csstyle = moduleDesc.csstyle;

        //多选
        var mulSel = moduleDesc.mulSel;
        if (mulSel) {
            inputprops.mode = "multiple";
            // inputprops.tokenSeparators = ",";
        }
        //设置是否自动选择第一个列表值，默认是true
        var autoSel = moduleDesc.autoSel;
        if (autoSel && this.state.store.length > 0) {
            inputprops.defaultValue = this.state.store[0].key;
        }
        //当下拉列表为空时显示的内容
        if (this.state.store.length < 1) {
            var emptyText = moduleDesc.emptyText;
            inputprops.placeholder = emptyText;
        }
        // 设置输入值是否严格为待选列表中的存在的值，默认值为false 未解决
        var forceSelection = moduleDesc.forceSelection;
        //不知道干嘛用的
        var anyMatch = moduleDesc.anyMatch;
        //delimiter : ",", // 多选数据分隔符
        //filterPickList : 'true',// 多选隐藏从下拉列表中的当前选定的值
        //selType: 'checkboxmodel', //多选样式
        //valueField : "c", // 组合框的值字段

        //queryMode : 'local', // 本地模式

        //typeAhead : true  //不知道什么意思
        //是否使用搜索框
        var showSearch = moduleDesc.showSearch;
        inputprops.showSearch = showSearch;
        // if (showSearch) {
        //     inputprops.showSearch = 'showSearch';
        // }
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.select_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        // let value = this.state.inputprops.value;
        // var newcomboBoxData = [];
        // if (value) {
        //     var valueList = value.split(",");//拆分
        //     for (var i = 0; i < valueList.length; i++) {
        //         var uceC = valueList[i];
        //         newcomboBoxData.push(uceC);
        //     }
        //     this.state.showValue = newcomboBoxData;
        //
        // } else {
        //     this.state.showValue = value;
        // }

        return (
            <FormItem {...this.state.formItemProps}>
                <Select  {...this.state.inputprops}>{this.state.store}</Select>
            </FormItem>
        );
    }
}
//给类添加公共方法
Object.assign(SgiFormSelect.prototype, sgiFormCtlBaseFun);
export { SgiFormSelect };
