import React from 'react';
import ReactDOM from 'react-dom';
import { Form, TimePicker } from 'antd';
const FormItem = Form.Item;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm';
import moment from 'moment';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun";

class SgiFormTimePicker extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    timePicker_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.functions, type);
    }


    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        // 步长都没有应用上
        var hourStep = moduleDesc.hourStep; //小时选项间隔
        if (hourStep) inputprops.hourStep = hourStep ;

        var minuteStep = moduleDesc.minuteStep; //分钟选项间隔
        if (minuteStep) inputprops.minuteStep = minuteStep;

        var secondStep = moduleDesc.secondStep; //秒选项间隔
        if (secondStep) inputprops.secondStep = secondStep;

        //csstyle 样式文件?这个我还不知道怎么用
        var csstyle = moduleDesc.csstyle;

        var timeFmt = moduleDesc.timeFmt; //日期格式
        if (timeFmt) {
            inputprops.format = timeFmt;
        }

        var placeholder = moduleDesc.inpPopTe;//提示框
        if (placeholder) {
            inputprops.placeholder = placeholder;
        }
        
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.timePicker_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        //日期格式转换  value值转换成日期格式数据
        let value = this.state.inputprops.value;
        let format = "HH:mm:ss";//this.state.inputprops.format; 2018.04.25-yly,时间控件没有格式编辑属性
        if (value) {
            this.state.showValue = moment(value, format);
        }
        
        let defaultValue = this.state.inputprops.defaultValue;
        if (defaultValue) {
            this.state.inputprops.defaultValue = moment(defaultValue, format);
        }
        
        return (
            <FormItem {...this.state.formItemProps}>
                <TimePicker {...this.state.inputprops} value={this.state.showValue} />
            </FormItem>
        );
    }
}

//给类添加公共方法
Object.assign(SgiFormTimePicker.prototype, sgiFormCtlBaseFun);
export { SgiFormTimePicker };
