import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Upload, Button, Icon } from 'antd';
const FormItem = Form.Item;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"


class SgiFormUpload extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);
        //初始化state属性
        this.initState();
        this.state.buttonProps = { //自定义的
            style: { width: "100%" },
        }
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {对象工厂} objFct
     * @param {make类型} type
     */
    upload_mk(panelModule, moduleDesc, bdInst, objFct, type) {

        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops, this.state.buttonProps);
        //转换form公共属性
        AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        setFormCtlLayout(moduleDesc, this.formItemProps, this.state.inputprops);
        //绑定值
        bindValue(this, moduleDesc, bdInst, objFct, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        bindEvent(this, moduleDesc, objFct, this.state.inputprops, this.state.functions, type);
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops, buttonProps) {
        var btnN = moduleDesc.btnN; // 按钮名称
        if (btnN) inputprops.btnN = btnN;

        // 关闭按钮图标 ?? 什么意思
        var closeI = moduleDesc.closeI;

        var cluW = moduleDesc.cluW;// 按钮宽度
        if (cluW) buttonProps.style.width = cluW;

        // 文件图标
        var fileNameI = moduleDesc.fileNameI;

        var iconPh = moduleDesc.iconPh;  // 按钮图标
        if (iconPh) inputprops.iconPh = iconPh;

        var mulSel = moduleDesc.mulSel;  // 设置是否允许多选
        if (mulSel) inputprops.multiple = mulSel;

        //只读，通过禁用就可以形式实现
        var isRead = moduleDesc.isRead;
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.upload_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        return (
            <FormItem {...this.state.formItemProps}>
                <Upload {...this.state.inputprops}>
                    <Button {...this.state.buttonProps}>
                        <Icon type="upload" />{this.state.inputprops.btnN}
                    </Button>
                </Upload>
            </FormItem>
        );
    }
}

//给类添加公共方法
Object.assign(SgiFormUpload.prototype, sgiFormCtlBaseFun);

export { SgiFormUpload };
