import React from 'react';
import ReactDOM from 'react-dom';
import { Card } from 'antd';
import { addCtnCommonAttribute } from "./SgiCtnComm"
import { convertModuleByGuid } from "./SgiCompComm"
import { ObjFactory } from '../sgiFactory/ObjFactory'
import style from './SgiPanel.css';
import { Resource } from '../sgiCommon/Resource';
import { AllCompGUID } from './SgiCompConstant';
// const TabPane = Tabs.TabPane;
// const Panel = Collapse.Panel;

class SgiPanel extends React.Component {

    //这个暂时不好用 以后在处理
    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);
        this.state = {
            //ctnProps: { style: {} },//form属性
            panelProps: { style: { heigth: '100%', width: '100%' } },//panel全局属性
            panelTitleProps: { style: {} },//panel的title属性
            panelBodyProps: { style: {} },//panel的body属性
            panelItems: [], //面板下控件数组loading
            loading: false,
            toolbarTopItems: [],
            toolbarBottomItems: []
        };
    }

    /**
     * 根据描述创建form
     * @param {父组件} panelModule 
     * @param {描述} moduleDesc       
     * @param {对象工厂} objFct 
     * @param {make类型} type 
     */
    panel_mk(panelModule, moduleDesc, objFct, type) {
        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        this.state.panelItems = []; //再次渲染的时候清空

        //转换基础属性
        this.AddAttribute(moduleDesc, this.state.panelProps, this.state.panelTitleProps, this.state.panelBodyProps, panelModule);
        //转换form公共属性
        addCtnCommonAttribute(this, moduleDesc, this.state.panelProps);
        //设置布局
        //this.setFormCtlLayout(moduleDesc, formProps);
        //绑定事件
        this.bindEvent(moduleDesc, this.state.panelProps);
        //组装form表单下的控件信息
        this.fitPanelItems(moduleDesc, this.state.panelItems, objFct, type);
    }

    /**
     * 绑定事件
     * @param {*} moduleDesc 
     * @param {*} formProps 
     */
    bindEvent(moduleDesc, formProps) {

    }

    /**
     * 根据描述组装子对象
     * @param {描述信息} moduleDesc 
     * @param {属性} formProps 
     */
    fitPanelItems = function (moduleDesc, panelItems, objFct, type) {
        var me = this;
        //form下的子节点添加到form组件中
        let cldSet = moduleDesc.cldSet;
        if (cldSet && cldSet.length && cldSet.length > 0) {
            cldSet.forEach((item, index) => {
                if (item.desId === AllCompGUID.TOOLBAR) {
                    if (!item.tlbAlg || item.tlbAlg == 'top' || item.tlbAlg == 'left') {
                        this.state.toolbarTopItems.push(convertModuleByGuid(this, item, null, objFct, type));
                    } else {
                        this.state.toolbarBottomItems.push(convertModuleByGuid(this, item, null, objFct, type));
                    }
                } else {
                    panelItems.push(convertModuleByGuid(me, item, null, objFct, type));
                }
            });
        }
    }

    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }


    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            let { panelModule, moduleDesc, objFct, type } = this.props;
            //组装属性
            this.panel_mk(panelModule, moduleDesc, objFct, type);
            this.loaded = true;
        }

        return (
            <div className={style.panel} {...this.state.panelProps}>
                {this.state.toolbarTopItems ? this.state.toolbarTopItems : null}
                <div style={{ height: '100%', width: '100%' }}>
                    <div className={style.title} {...this.state.panelTitleProps}>
                        <span>{this.state.panelTitleProps.title}</span>
                    </div>
                    <div className={style.body} {...this.state.panelBodyProps}>
                        {this.state.panelItems}
                        {this.props.children}
                    </div>
                </div>
                {this.state.toolbarBottomItems ? this.state.toolbarBottomItems : null}
            </div>
        )
    }



    /**
     * 属性转换
     * @param {描述信息} moduleDesc 
     * @param {属性} panelProps 
     */
    AddAttribute = function (moduleDesc, panelProps, panelTitleProps, panelBodyProps, panelModule) {
        var type;
        if (panelModule && panelModule.state && panelModule.state.itemPanelType) {
            type = panelModule.state.itemPanelType;
        }

        var text = Resource.getTRByPrm(moduleDesc).te; //form标题
        if (text) panelTitleProps.title = text;

        var ttlAlgn = moduleDesc.ttlAlgn; //form标题对齐方式
        if (ttlAlgn) panelTitleProps.style['text-align'] = ttlAlgn;

        var isTtl = moduleDesc.isTtl; //form是否显示标题
        if (!isTtl) {
            panelTitleProps.style.display = "none";
        } else {
            panelTitleProps.style.display = undefined;
        }

        var isScl = moduleDesc.isScl; //form是否可以滚动??没实现
        //if(isScl) panelBodyProps.style.display

        if (type === 'tabs' || type == 'cos') {
            panelTitleProps.style.display = "none";
        }

        var icon = moduleDesc.icon; //form背景图片??没实现        
        var bdsty = moduleDesc.bdsty; //form背景颜色??没实现        
        var ttlAlg = moduleDesc.ttlAlg; //form标题位置??没实现
        var isCls = moduleDesc.isCls; //form是否可以关闭??没实现
        var isFrm = moduleDesc.isFrm; //form是否填充??没实现-----del     
        var html = moduleDesc.html; //form显示html元素??没实现     
        var isDis = moduleDesc.isDis; //form是否禁用??没实现 
        var csstyle = moduleDesc.csstyle; //form样式??没实现
        var flx = moduleDesc.flx; //form占比??没实      
    }



}
export { SgiPanel };