import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Modal, Button, Row, Col } from 'antd';
import { Divider } from 'antd';
const FormItem = Form.Item;
import { PrmFactory } from '../sgiFactory/PrmFactory'
import { addCtnCommonAttribute } from "./SgiCtnComm"
import { Resource } from '../sgiCommon/Resource';
import { SgiMainComp } from './SgiMainComp'
import { ObjFactory } from '../sgiFactory/ObjFactory'
import { SgiPanel } from '../sgiComp/SgiPanel'
import { convertModuleByGuid } from "./SgiCompComm"
import { addSgiSplitterCtlDndInfo } from '../sgiDndDev/sgiDndDevComFun'

class SgiSplitter extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        //初始化state
        this.state = {
            json: undefined,
            formProps: { style: { height: '100%', width: '100%' } },
            formItems: [], //form下控件数组
            loading: false
        };
    }

    /**
     * 根据描述创建文本框
     * @param {弹出页面guid} uid
     * @param {对象工厂} objFct
     * @param {弹出窗标题} curtitle
     */
    splitter_mk(panelModule, moduleDesc, objFct, type) {
        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }
        this.state.formItems = []; //再次渲染的时候清空
        //转换基础属性
        this.AddAttribute(moduleDesc, this.state.formProps);
        //转换form公共属性
        addCtnCommonAttribute(this, moduleDesc, this.state.formProps);
        //组装分割面板数据
        this.setFormCtlItems(moduleDesc, this.state.formItems);
        //添加拖拽布局信息 根据type类型
        addSgiSplitterCtlDndInfo(this, this.state.formItems, this.state.formProps, type);
    }


    AddAttribute = function (moduleDesc, formProps) {

    }


    /**
     * 添加子控件
     */
    setFormCtlItems = function (moduleDesc, formItems) {
        let { bdInst, objFct, type } = this.props;
        let colList;
        //分割比例
        var p = moduleDesc.sptSca;
        var ps = p.split(",");

        //计数
        var sumPs = 0;
        for (var i = 0; i < ps.length; i++) {
            sumPs += parseInt(ps[i]);
        }
        var isEdwSpt = moduleDesc.isEdwSpt;//纵向分割

        colList = [];
        var children = moduleDesc.cldSet;
        if (children) {
            var childSize = children.length;
            if (childSize != 0) {
                for (var i = 0; i < childSize; i++) {
                    if (!ps[i]) {
                        ps[i] = 0;
                    }
                    var span = Math.round((parseInt(ps[i]) / sumPs) * 24);
                    var height1 = (parseInt(ps[i]) / sumPs) * 100 + "%";

                    if (isEdwSpt) {
                        colList.push(<Row style={{ height: height1, width: '100%' }} >
                            {convertModuleByGuid(this, children[i], bdInst, objFct, type)}</Row>)
                    } else {
                        colList.push(<Col span={span} style={{ height: '100%' }}>
                            {convertModuleByGuid(this, children[i], bdInst, objFct, type)}</Col>)
                    }
                }
                if (isEdwSpt) {
                    formItems.push(colList);
                } else {
                    formItems.push(<Row style={{ height: '100%', width: '100%' }} > {colList}</Row >);
                }
            }
        }
    }

    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.splitter_mk(panelModule, moduleDesc, objFct, type);
            this.loaded = true;
        }

        return (
            <div {...this.state.formProps}>
                {this.state.formItems}
            </div>
        );
    }
}

export { SgiSplitter };
