import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Input, Steps } from 'antd';
import { sgiFormCtlBaseFun } from "./sgiFormCtlBaseFun"
const Step = Steps.Step;
import { bindValue, bindEvent, setFormCtlLayout, AddFormCtlCommonAttribute } from './sgiFormCtlComm'
import  {StandardCode} from '../sgiCommon/StandardCode';


class SgiSteps extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);

        //初始化state属性
        this.initState();
        this.state.store = []; //下拉框内容
        this.state.current = 0;
    }

    /**
     * 根据描述创建文本框
     * @param {父组件} panelModule
     * @param {组件描述} moduleDesc
     * @param {绑定实例ID} bdInst
     * @param {当前工作区} ws
     * @param {make类型} type
     */
    steps_mk(panelModule, moduleDesc, bdInst, workspace, type) {

        //获取需要展示的数据信息
        var moduleDesc = this.props.moduleDesc;
        if (!moduleDesc) {
            return;
        }
        //组装下拉框内容
        this.fitSelectOption(moduleDesc);
        //转换基础属性
        this.AddInputAttribute(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //转换form公共属性
        // AddFormCtlCommonAttribute(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //设置布局
        // setFormCtlLayout(moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定事件
        // bindEvent(this, moduleDesc, this.state.formItemProps, this.state.inputprops);
        //绑定值
        // bindValue(this, moduleDesc, bdInst, this.state.formItemProps, this.state.inputprops);
    }

    /**
     * 组装下拉框内容
     * @param {描述} moduleDesc
     */
    fitSelectOption(moduleDesc) {

        this.state.store = [];
        var scId = moduleDesc.rSC; //绑定实例名
        if(!scId){
            return;
        }
        // 下拉窗列表值在标准代码中的id
        var comboBoxData = StandardCode.getSC(scId);
        if (!comboBoxData) {
            return;
        }

        let scList = [];
        var size = comboBoxData.length;
        if(!size == 0){
            for (let i = 0; i < size; i++) {
                var item = comboBoxData[i];
                scList.push({ te: (item.te), c: (item.c) });
            }
            scList.forEach((item, index) => {
                this.state.store.push(<Step key={item.c} title={item.te} />);
            })
        }
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formItem
     * @param {属性} inputprops
     */
    AddInputAttribute(moduleDesc, formItem, inputprops) {
        //csstyle 样式文件?这个我还不知道怎么用
        // var csstyle = moduleDesc.csstyle;

        // 指定当前步骤，从 0 开始记数。
        var current = moduleDesc.current;
        if(current) inputprops.current = current;

        //点状步骤条
        var progressDot = moduleDesc.progressDot;
        if(progressDot) inputprops.progressDot = progressDot;

        //步骤条方向
        var direction = moduleDesc.direction;
        if(direction) inputprops.direction = direction;
    }

    // 下一步
    next() {
        let max = this.state.store.length - 1;
        if (this.state.current < max) {
            let current = this.state.current + 1;
            this.setState({ current });
        }
    }
    // 上一步
    prev() {
        if (this.state.current > 0) {
            let current = this.state.current - 1;
            this.setState({ current });
        }
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            var { panelModule, moduleDesc, bdInst, objFct, type } = this.props;
            //组装属性 初始化属性到this.state
            this.steps_mk(panelModule, moduleDesc, bdInst, objFct, type);
            this.loaded = true;
        }

        const { current } = this.state;
        return (
            <Steps  {...this.state.inputprops} current={current}>{this.state.store}</Steps>
        );
    }
}
//给类添加公共方法
Object.assign(SgiSteps.prototype, sgiFormCtlBaseFun);
export { SgiSteps };
