import React from 'react';
import ReactDOM from 'react-dom';
import { Tabs, Collapse } from 'antd';
const TabPane = Tabs.TabPane;
import { addCtnCommonAttribute } from "./SgiCtnComm"
import { convertModuleByGuid } from "./SgiCompComm"
import { ObjFactory } from '../sgiFactory/ObjFactory'
import { uuid } from "../sgiCommon/sgiCommon";
import { SgiEventHandler } from './SgiEventHandler';
import { Resource } from '../sgiCommon/Resource';
import { addTabCtlDndInfo } from '../sgiDndDev/sgiDndDevComFun'
import { sgiLogger } from '../sgiCommon/sgiLogger'
// const Panel = Collapse.Panel;
class SgiTabs extends React.Component {

    //这个暂时不好用 以后在处理
    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };

    constructor(props) {
        super(props);
        this.state = {
            itemPanelType: "tabs",//区分是tab还是折叠面板的 普通面板整合tabpane和折叠panel
            tabsProps: { style: { height: "100%", width: "100%" } },//form属性
            tabsItems: [], //form下控件数组
            tabBarExtraContent: {},
            functions: {},
            loading: false
        };
    }

    /**
     * 根据描述创建form
     * @param {父组件} panelModule
     * @param {描述} moduleDesc
     * @param {对象工厂} objFct
     * @param {make类型} type
     */
    tabs_mk(panelModule, moduleDesc, objFct, type) {
        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }

        this.state.tabsItems = []; //再次渲染的时候清空

        //转换基础属性
        this.AddAttribute(moduleDesc, this.state.tabsProps, this);
        //转换form公共属性
        addCtnCommonAttribute(this, moduleDesc, this.state.tabsProps);
        //绑定事件
        this.bindEvent(moduleDesc, this.state.tabsProps, this.state.functions, type);
        //组装form表单下的控件信息
        this.fitTabsItems(moduleDesc, this.state.tabsItems, objFct, type);
        //组装tabBarExtraContent下的控件
        this.fitTabExtraContent(moduleDesc, this.state.tabBarExtraContent, objFct, type);
        //添加拖拽布局信息 根据type类型
        addTabCtlDndInfo(this, this.state.tabsItems, this.state.tabsProps, type);
    }

    /**
     * 绑定事件
     * @param {*} moduleDesc
     * @param {*} tabsProps
     */
    bindEvent(moduleDesc, tabsProps, functions, type) {
        //拖拽模式 不生成事件
        var lsn = moduleDesc.tabLsn;// 选项卡监听器
        // var lsn = "console.log('11111111111111111',ComponentManager)"
        if (lsn && type != 'dnd') {
            try {
                var $tcl = new Function("module", "objFct", "activeKey", lsn);
                functions.tab = $tcl;
            } catch (e) {
                sgiLogger.error(e);
            }
        }
        tabsProps.onChange = SgiEventHandler.tcl.bind(this);
    }


    /**
     * 根据描述组装子 操作按钮
     * @param {描述信息} moduleDesc
     * @param {属性} formProps
     */
    fitTabExtraContent = function (moduleDesc, tabsItems, objFct, type) {
        var me = this;
        //form下的子节点添加到form组件中
        // me.itemPanelType = 'tabs';

        // tabBarExtraContent
    }

    /**
    * 根据描述组装子对象
    * @param {描述信息} moduleDesc
    * @param {属性} formProps
    */
    fitTabsItems = function (moduleDesc, tabsItems, objFct, type) {
        var me = this;
        //form下的子节点添加到form组件中
        // me.itemPanelType = 'tabs';
        // console.log("tabs");

        let cldSet = moduleDesc.cldSet;
        if (cldSet && cldSet.length && cldSet.length > 0) {
            let tabPane;
            cldSet.forEach((item, index) => {
                let { cId, te, isDis } = item;
                tabPane = { forceRender: true }; //默认渲染
                if (!cId) {
                    cId = uuid(8);
                    item.cId = cId;
                }
                if (te) tabPane.tab = Resource.getTRByPrm(item).te;
                if (cId) tabPane.key = cId;
                if (isDis) tabPane.disabled = isDis;
                tabsItems.push(<TabPane {...tabPane}>{convertModuleByGuid(me, item, null, objFct, type)}</TabPane>);
            });
        }
    }

    setActiveItem = (activeKey) => {
        this.state.tabsProps.onChange(activeKey);
        this.render();
    }
    /**
     * 获取当前激活面板的组件标识
     * @return {[type]} [description]
     */
    getActiveItem = () => {
        return this.state.activeKey;
    }

    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            let { panelModule, moduleDesc, objFct, type } = this.props;
            //组装属性
            this.tabs_mk(panelModule, moduleDesc, objFct, type);
            this.loaded = true;
        }

        return (
            <Tabs {...this.state.tabsProps} activeKey={this.state.activeKey}>
                {this.state.tabsItems}
            </Tabs>
        )
    }

    /**
     * 属性转换
     * @param {描述信息} moduleDesc
     * @param {属性} formProps
     */
    AddAttribute = function (moduleDesc, tabsProps, tabs) {
        //选项卡位置 left、top、right、bottom
        let tabPst = moduleDesc.tabPst; //tab面板位置
        if (tabPst) tabsProps.tabPosition = moduleDesc.tabPst;
        //选项卡按钮
        tabsProps.type = "card"; //先默认这个 以后再去实现其他的属性
        // tabsProps.hideAdd =true;
        //初始化激活的面板
        let atvTab = moduleDesc.atvTab;
        if (atvTab) {
            tabsProps.defaultActiveKey = atvTab;
            tabs.state.activeKey = tabsProps.defaultActiveKey;
        }

    }
}


export { SgiTabs };
