import { Array } from '../sgiCommon/sgiCommon'
/**
 * 树控件的基础方法，供树控件继承
 * wangz
 * 2018.3.12
 */

"use strict"
/**
 * [树对象方法]
 * @type {Object}
 */
var sgiTreeBaseFun = {

    //刷新树方法
    refreshTree: function (treeData) {
        if (treeData) {
            this.state.treeData = treeData;
            this.setState({ loading: true });
        }
    },

    /**
    * 获取已选中/勾选节点
    */
    getSelection: function () {
        return this.state.selectedNodes;
    },

    /**
    * 选中树的某个节点？？？
    * 没有key做不到
    * @param {info} info要选中的节点
    */
    select: function (info) {
        if (!info || !info[this.state.key]) {
            return;
        }
        var e = {
            event: "select",
            selected: true,
            node: { props: { itemData: info } }
        };
        this.state.treeProps.onSelect([info[this.state.key]], e);
    },

    /**
    * 展开树的某个节点
    * @param {treeNode} info要展开的节点
    */
    expand: function (info) {
        if (!info || !info[this.state.key]) {
            return;
        }
        this.state.expandedKeys.push(info[this.state.key]);
        this.setState({ loading: false });
    },

    /**
    * 选中首行？？？
    * 实际上也是选中某节点，做不到
    */
    // selFirst: function () {
    //     var treeData = this.state.treeData;
    //     if (treeData) {
    //         this.select(treeData[0]);
    //     }
    // },

    /**
    * 删除树的选中数据
    */
    delTreeSel: function () {
        var selectedNodes = this.state.selectedNodes;
        var treeData = this.state.treeData;
        if (treeData && selectedNodes) {
            selectedNodes.map((item, index) => {
                //获取当前节点的父节点         
                this.delTreeNode(item);
            });
            this.state.selectedKeys = [];//既然删除了那就置空喽
            this.state.selectedNodes = [];
            // return treeData;
            this.setState({ loading: false });
        } else {
            return null;
        }
    },
    delTreeNode: function (node) {
        let parentNode = this.findNodeByKey(null, node[this.state.pKey]);
        let children;
        if (parentNode) {
            children = parentNode[this.state.childrenName]
        } else {
            children = this.state.treeData;
        }
        Array.remove(children, node);
    }
    // eq: function (a, b) {
    //     //获取a和b的属性长度
    //     var propsA = Object.getOwnPropertyNames(a),
    //         propsB = Object.getOwnPropertyNames(b);
    //     if (propsA.length != propsB.length) {
    //         return false;
    //     }
    //     for (var i = 0; i < propsA.length; i++) {
    //         var propName = propsA[i];
    //         //如果对应属性对应值不相等，则返回false
    //         if (a[propName] !== b[propName]) {
    //             return false;
    //         }
    //     }
    //     return true;
    // },
    // /**
    //  * 删除树的一个节点
    //  * @param  {[object]} node [节点数据信息]
    //  * @return {[Array]}      [删除后的treeData]
    //  */
    // delTreeNode: function (node) {
    //     var treeData = this.state.treeData;
    //     var func1 = function (treeData, node, me) {
    //         var have = null;
    //         var i = 0;
    //         for (; i < treeData.length; i++) {
    //             have = (treeData[i] == node) || me.eq(treeData[i], node);
    //             if (have == true) {//找到此节点，然后删除
    //                 treeData.splice(i, 1);
    //                 break;
    //             } else if (have == false) {
    //                 continue;
    //             }
    //         }

    //         if (have == true) {
    //             return have;
    //         } else if (have == false) {//未找到，遍历查找子节点
    //             for (var j = 0; j < treeData.length; j++) {
    //                 var item = treeData[j];
    //                 if (item.cldSet && item.cldSet.length > 0) {
    //                     have = func1(item.cldSet, node, me);
    //                 }
    //                 if (have == true) {
    //                     break;
    //                 }
    //             }
    //             return have;
    //         }
    //     }

    //     if (treeData && node) {
    //         func1(treeData, node, this);
    //         this.refreshTree(treeData);
    //         return treeData;
    //     } else {
    //         return null;
    //     }
    // },

}




/**
 * 树节点方法
 * @type {Object}
 */
var sgiTreeNodeFun = {

    /**
    * 判断节点是否是根节点
    */
    isRoot: function () {
        if (this && this.parentNode) {
            return false;
        } else {
            return true;
        }
    },
    /**
     * 取得父节点
     * @return {[object]} [父节点对象]
     */
    gainParent: function () {
        return this.parentNode;
    },


    getData() {
        return this.itemData;
    },

    /**
    * 取得根节点信息
    */
    gainRoot: function () {
        var p;
        var p2 = this;
        var findRoot = function () {
            p = p2.parentNode;
            if (p != null) {
                while (p.props != null) {
                    p2 = p.props;
                    return findRoot();
                }
            } else {//p=null
                return p2;
            }
        }
        p2 = findRoot();
        return p2;
    },
    /**
    * 节点是否有下级节点
    */
    hasChild: function () {
        if (this.itemData.cldSet && this.itemData.cldSet.length) {
            return true;
        } else {
            return false;
        }
    },
    /**
     * 判断是否是叶子节点
     * @return {[boolean]} [true:是叶子节点，false:不是叶子节点]
     */
    leaf: function () {
        if (this.isLeaf = true) {
            return true;
        } else {
            return false;
        }
    },
    /**
     * 获取树的下一级节点
     * @return {[array]} [子节点数据（不含结构）]
     */
    gainChild: function () {
        if (this.itemData.cldSet && this.itemData.cldSet.length) {
            return this.itemData.cldSet;
        } else {
            return null;
        }
    },
    /**
     * 在当前节点下添加子节点
     * @param  {[object]} record [要添加的节点数据]
     * @return {[type]}        [description]
     */
    appendChild: function (record) {
        if (this.itemData.cldSet) {
            this.itemData.cldSet.push(record);
        } else {
            this.itemData.cldSet = [];
            this.itemData.cldSet.push(record);
        }
    },
    /**
     * 移除树节点（非根节点）
     * @return {[type]} [description]
     */
    remove: function () {
        var me = this.itemData;
        if (this && this.parentNode && this.parentNode.props.itemData) {
            var children = this.parentNode.props.itemData.cldSet;
            if (children) {
                children.map((item, index) => {
                    if (me == item) {
                        children.splice(index, 1);
                    }
                });
            }
        }
        // else {
        //     var treeData = this.root.props.children;//节点结构数组
        //     if (treeData && me) {
        //         treeData.map((item, index) => {
        //             if (me == item.props.itemData) {
        //                 treeData.splice(index, 1);
        //             }
        //         });
        //         //this.refreshTree(treeData);
        //         return treeData;
        //     } else {
        //         return null;
        //     }
        // }
    },
    /**
     * 删除此节点下全部子节点
     * @return {[type]} [description]
     */
    removeAllChild: function () {
        this.itemData.cldSet = [];
    },
    /**
     * 查找属性等于指定值的第一个子项
     * @param  {[String]} attribute [属性名称]
     * @param  {[Object]} value     [要搜索的值]
     * @param  {[Boolean]} deep = false      [true表示遍历所有子节点，false表示只遍历下一级]
     * @return {[type]}           [找到的子元素，如果没有找到，则返回null]
     */
    findChild: function (attribute, value, deep) {
        return this.findChildBy(function () {
            return this[attribute] == value;
        }, null, deep);
    },
    /**
     * 通过自定义函数查找第一个子项。 如果传递的函数返回true，则该子项匹配。
     * @param  {Function} fn    [如果通过的节点是所需的节点，fn一个必须返回true的函数。]
     * @param  {[Object]}   scope [执行该函数的作用域（此引用）。 默认为正在测试的节点。]
     * @param  {[Boolean]}   deep = false  [true：搜索比直接子节点更深的节点]
     * @return {[type]}         [找到的子元素，如果没有找到，则返回null]
     */
    findChildBy: function (fn, scope, deep) {
        var cs = [];
        if (this.children) {
            cs = this.children[0];
        }
        var len = cs.length,
            i = 0,
            n, res;
        for (; i < len; i++) {
            n = cs[i].props;
            if (fn.call(scope || n.itemData, n.itemData) === true) {
                return n;
            } else if (deep) {
                res = n.findChildBy(fn, scope, deep);
                if (res !== null) {
                    return res;
                }
            }
        }
        return null;
    },
}

export { sgiTreeBaseFun, sgiTreeNodeFun }
