import React from 'react';
import ReactDOM from 'react-dom';
import { Card, Icon } from 'antd';

const gridStyle = {
  width: '16.66%',
  height: '112px',
  textAlign: 'center',
};
const iconStyle={
    fontSize: 26,
    // color: '#08c'
};

const Directional_Icons = [
    <Icon type="step-backward" style={iconStyle} />,
    <Icon type="step-forward" style={iconStyle} />,
    <Icon type="fast-backward" style={iconStyle} />,
    <Icon type="fast-forward" style={iconStyle} />,
    <Icon type="shrink" style={iconStyle} />,
    <Icon type="arrows-alt" style={iconStyle} />,

    <Icon type="down" style={iconStyle} />,
    <Icon type="up" style={iconStyle} />,
    <Icon type="left" style={iconStyle} />,
    <Icon type="right" style={iconStyle} />,
    <Icon type="caret-up" style={iconStyle} />,
    <Icon type="caret-down" style={iconStyle} />,

    <Icon type="caret-left" style={iconStyle} />,
    <Icon type="caret-right" style={iconStyle} />,
    <Icon type="up-circle" style={iconStyle} />,
    <Icon type="down-circle" style={iconStyle} />,
    <Icon type="left-circle" style={iconStyle} />,
    <Icon type="right-circle" style={iconStyle} />,

    <Icon type="up-circle-o" style={iconStyle} />,
    <Icon type="down-circle-o" style={iconStyle} />,
    <Icon type="right-circle-o" style={iconStyle} />,
    <Icon type="left-circle-o" style={iconStyle} />,
    <Icon type="double-right" style={iconStyle} />,
    <Icon type="double-left" style={iconStyle} />,

    <Icon type="verticle-left" style={iconStyle} />,
    <Icon type="verticle-right" style={iconStyle} />,
    <Icon type="forward" style={iconStyle} />,
    <Icon type="backward" style={iconStyle} />,
    <Icon type="rollback" style={iconStyle} />,
    <Icon type="enter" style={iconStyle} />,

    <Icon type="retweet" style={iconStyle} />,
    <Icon type="swap" style={iconStyle} />,
    <Icon type="swap-left" style={iconStyle} />,
    <Icon type="swap-right" style={iconStyle} />,
    <Icon type="arrow-up" style={iconStyle} />,
    <Icon type="arrow-down" style={iconStyle} />,

    <Icon type="arrow-left" style={iconStyle} />,
    <Icon type="arrow-right" style={iconStyle} />,
    <Icon type="play-circle" style={iconStyle} />,
    <Icon type="play-circle-o" style={iconStyle} />,
    <Icon type="up-square" style={iconStyle} />,
    <Icon type="down-square" style={iconStyle} />,

    <Icon type="left-square" style={iconStyle} />,
    <Icon type="right-square" style={iconStyle} />,
    <Icon type="up-square-o" style={iconStyle} />,
    <Icon type="down-square-o" style={iconStyle} />,
    <Icon type="left-square-o" style={iconStyle} />,
    <Icon type="right-square-o" style={iconStyle} />,

    <Icon type="login" style={iconStyle} />,
    <Icon type="logout" style={iconStyle} />,
    <Icon type="menu-fold" style={iconStyle} />,
    <Icon type="menu-unfold" style={iconStyle} />,
];
const Suggested_Icons = [
    <Icon type="question" style={iconStyle} />,
    <Icon type="question-circle-o" style={iconStyle} />,
    <Icon type="question-circle" style={iconStyle} />,
    <Icon type="plus" style={iconStyle} />,
    <Icon type="plus-circle-o" style={iconStyle} />,
    <Icon type="plus-circle" style={iconStyle} />,

    <Icon type="pause" style={iconStyle} />,
    <Icon type="pause-circle-o" style={iconStyle} />,
    <Icon type="pause-circle" style={iconStyle} />,
    <Icon type="minus" style={iconStyle} />,
    <Icon type="minus-circle-o" style={iconStyle} />,
    <Icon type="minus-circle" style={iconStyle} />,

    <Icon type="plus-square" style={iconStyle} />,
    <Icon type="plus-square-o" style={iconStyle} />,
    <Icon type="minus-square" style={iconStyle} />,
    <Icon type="minus-square-o" style={iconStyle} />,
    <Icon type="info" style={iconStyle} />,
    <Icon type="info-circle-o" style={iconStyle} />,

    <Icon type="info-circle" style={iconStyle} />,
    <Icon type="exclamation" style={iconStyle} />,
    <Icon type="exclamation-circle-o" style={iconStyle} />,
    <Icon type="exclamation-circle" style={iconStyle} />,
    <Icon type="close" style={iconStyle} />,
    <Icon type="close-circle" style={iconStyle} />,

    <Icon type="close-circle-o" style={iconStyle} />,
    <Icon type="close-square" style={iconStyle} />,
    <Icon type="close-square-o" style={iconStyle} />,
    <Icon type="check" style={iconStyle} />,
    <Icon type="check-circle" style={iconStyle} />,
    <Icon type="check-circle-o" style={iconStyle} />,

    <Icon type="check-square" style={iconStyle} />,
    <Icon type="check-square-o" style={iconStyle} />,
    <Icon type="clock-circle-o" style={iconStyle} />,
    <Icon type="clock-circle" style={iconStyle} />,
    <Icon type="warning" style={iconStyle} />,
];
const Application_Icons = [
    <Icon type="lock" style={iconStyle} />,
    <Icon type="unlock" style={iconStyle} />,
    <Icon type="area-chart" style={iconStyle} />,
    <Icon type="pie-chart" style={iconStyle} />,
    <Icon type="bar-chart" style={iconStyle} />,
    <Icon type="dot-chart" style={iconStyle} />,

    <Icon type="bars" style={iconStyle} />,
    <Icon type="book" style={iconStyle} />,
    <Icon type="calendar" style={iconStyle} />,
    <Icon type="cloud" style={iconStyle} />,
    <Icon type="cloud-download" style={iconStyle} />,
    <Icon type="code" style={iconStyle} />,

    <Icon type="code-o" style={iconStyle} />,
    <Icon type="copy" style={iconStyle} />,
    <Icon type="credit-card" style={iconStyle} />,
    <Icon type="delete" style={iconStyle} />,
    <Icon type="desktop" style={iconStyle} />,
    <Icon type="download" style={iconStyle} />,

    <Icon type="edit" style={iconStyle} />,
    <Icon type="ellipsis" style={iconStyle} />,
    <Icon type="file" style={iconStyle} />,
    <Icon type="file-text" style={iconStyle} />,
    <Icon type="file-unknown" style={iconStyle} />,
    <Icon type="file-pdf" style={iconStyle} />,

    <Icon type="file-word" style={iconStyle} />,
    <Icon type="file-excel" style={iconStyle} />,
    <Icon type="file-jpg" style={iconStyle} />,
    <Icon type="file-ppt" style={iconStyle} />,
    <Icon type="file-markdown" style={iconStyle} />,
    <Icon type="file-add" style={iconStyle} />,

    <Icon type="folder" style={iconStyle} />,
    <Icon type="folder-open" style={iconStyle} />,
    <Icon type="folder-add" style={iconStyle} />,
    <Icon type="hdd" style={iconStyle} />,
    <Icon type="frown" style={iconStyle} />,
    <Icon type="frown-o" style={iconStyle} />,

    <Icon type="meh" style={iconStyle} />,
    <Icon type="meh-o" style={iconStyle} />,
    <Icon type="smile" style={iconStyle} />,
    <Icon type="smile-o" style={iconStyle} />,
    <Icon type="inbox" style={iconStyle} />,
    <Icon type="laptop" style={iconStyle} />,

    <Icon type="appstore-o" style={iconStyle} />,
    <Icon type="appstore" style={iconStyle} />,
    <Icon type="line-chart" style={iconStyle} />,
    <Icon type="link" style={iconStyle} />,
    <Icon type="mail" style={iconStyle} />,
    <Icon type="mobile" style={iconStyle} />,

    <Icon type="notification" style={iconStyle} />,
    <Icon type="paper-clip" style={iconStyle} />,
    <Icon type="picture" style={iconStyle} />,
    <Icon type="poweroff" style={iconStyle} />,
    <Icon type="reload" style={iconStyle} />,
    <Icon type="search" style={iconStyle} />,

    <Icon type="setting" style={iconStyle} />,
    <Icon type="share-alt" style={iconStyle} />,
    <Icon type="shopping-cart" style={iconStyle} />,
    <Icon type="tablet" style={iconStyle} />,
    <Icon type="tag" style={iconStyle} />,
    <Icon type="tag-o" style={iconStyle} />,

    <Icon type="tags" style={iconStyle} />,
    <Icon type="tags-o" style={iconStyle} />,
    <Icon type="to-top" style={iconStyle} />,
    <Icon type="upload" style={iconStyle} />,
    <Icon type="user" style={iconStyle} />,
    <Icon type="video-camera" style={iconStyle} />,

    <Icon type="home" style={iconStyle} />,
    <Icon type="loading" style={iconStyle} />,
    <Icon type="loading-3-quarters" style={iconStyle} />,
    <Icon type="cloud-upload-o" style={iconStyle} />,
    <Icon type="cloud-download-o" style={iconStyle} />,
    <Icon type="cloud-upload" style={iconStyle} />,

    <Icon type="cloud-o" style={iconStyle} />,
    <Icon type="star-o" style={iconStyle} />,
    <Icon type="star" style={iconStyle} />,
    <Icon type="heart-o" style={iconStyle} />,
    <Icon type="heart" style={iconStyle} />,
    <Icon type="environment" style={iconStyle} />,

    <Icon type="environment-o" style={iconStyle} />,
    <Icon type="eye" style={iconStyle} />,
    <Icon type="eye-o" style={iconStyle} />,
    <Icon type="camera" style={iconStyle} />,
    <Icon type="camera-o" style={iconStyle} />,
    <Icon type="save" style={iconStyle} />,

    <Icon type="team" style={iconStyle} />,
    <Icon type="solution" style={iconStyle} />,
    <Icon type="phone" style={iconStyle} />,
    <Icon type="filter" style={iconStyle} />,
    <Icon type="exception" style={iconStyle} />,
    <Icon type="export" style={iconStyle} />,

    <Icon type="customer-service" style={iconStyle} />,
    <Icon type="qrcode" style={iconStyle} />,
    <Icon type="scan" style={iconStyle} />,
    <Icon type="like" style={iconStyle} />,
    <Icon type="like-o" style={iconStyle} />,
    <Icon type="dislike" style={iconStyle} />,

    <Icon type="dislike-o" style={iconStyle} />,
    <Icon type="message" style={iconStyle} />,
    <Icon type="pay-circle" style={iconStyle} />,
    <Icon type="pay-circle-o" style={iconStyle} />,
    <Icon type="calculator" style={iconStyle} />,
    <Icon type="pushpin" style={iconStyle} />,

    <Icon type="pushpin-o" style={iconStyle} />,
    <Icon type="bulb" style={iconStyle} />,
    <Icon type="select" style={iconStyle} />,
    <Icon type="switcher" style={iconStyle} />,
    <Icon type="rocket" style={iconStyle} />,
    <Icon type="bell" style={iconStyle} />,

    <Icon type="disconnect" style={iconStyle} />,
    <Icon type="database" style={iconStyle} />,
    <Icon type="compass" style={iconStyle} />,
    <Icon type="barcode" style={iconStyle} />,
    <Icon type="hourglass" style={iconStyle} />,
    <Icon type="key" style={iconStyle} />,

    <Icon type="flag" style={iconStyle} />,
    <Icon type="layout" style={iconStyle} />,
    <Icon type="printer" style={iconStyle} />,
    <Icon type="sound" style={iconStyle} />,
    <Icon type="usb" style={iconStyle} />,
    <Icon type="skin" style={iconStyle} />,

    <Icon type="tool" style={iconStyle} />,
    <Icon type="sync" style={iconStyle} />,
    <Icon type="wifi" style={iconStyle} />,
    <Icon type="car" style={iconStyle} />,
    <Icon type="schedule" style={iconStyle} />,
    <Icon type="user-add" style={iconStyle} />,

    <Icon type="user-delete" style={iconStyle} />,
    <Icon type="usergroup-add" style={iconStyle} />,
    <Icon type="usergroup-delete" style={iconStyle} />,
    <Icon type="man" style={iconStyle} />,
    <Icon type="woman" style={iconStyle} />,
    <Icon type="shop" style={iconStyle} />,

    <Icon type="gift" style={iconStyle} />,
    <Icon type="idcard" style={iconStyle} />,
    <Icon type="medicine-box" style={iconStyle} />,
    <Icon type="red-envelope" style={iconStyle} />,
    <Icon type="coffee" style={iconStyle} />,
    <Icon type="copyright" style={iconStyle} />,

    <Icon type="trademark" style={iconStyle} />,
    <Icon type="safety" style={iconStyle} />,
    <Icon type="wallet" style={iconStyle} />,
    <Icon type="bank" style={iconStyle} />,
    <Icon type="trophy" style={iconStyle} />,
    <Icon type="contacts" style={iconStyle} />,

    <Icon type="global" style={iconStyle} />,
    <Icon type="shake" style={iconStyle} />,
    <Icon type="api" style={iconStyle} />,
    <Icon type="fork" style={iconStyle} />,
    <Icon type="dashboard" style={iconStyle} />,
    <Icon type="form" style={iconStyle} />,

    <Icon type="table" style={iconStyle} />,
    <Icon type="profile" style={iconStyle} />,
];
const Brand_and_Logos = [
    <Icon type="android" style={iconStyle} />,
    <Icon type="android-o" style={iconStyle} />,
    <Icon type="apple" style={iconStyle} />,
    <Icon type="apple-o" style={iconStyle} />,
    <Icon type="windows" style={iconStyle} />,
    <Icon type="windows-o" style={iconStyle} />,

    <Icon type="ie" style={iconStyle} />,
    <Icon type="chrome" style={iconStyle} />,
    <Icon type="github" style={iconStyle} />,
    <Icon type="aliwangwang" style={iconStyle} />,
    <Icon type="aliwangwang-o" style={iconStyle} />,
    <Icon type="dingding" style={iconStyle} />,

    <Icon type="dingding-o" style={iconStyle} />,
    <Icon type="weibo-square" style={iconStyle} />,
    <Icon type="weibo-circle" style={iconStyle} />,
    <Icon type="taobao-circle" style={iconStyle} />,
    <Icon type="html5" style={iconStyle} />,
    <Icon type="weibo" style={iconStyle} />,

    <Icon type="twitter" style={iconStyle} />,
    <Icon type="wechat" style={iconStyle} />,
    <Icon type="youtube" style={iconStyle} />,
    <Icon type="alipay-circle" style={iconStyle} />,
    <Icon type="taobao" style={iconStyle} />,
    <Icon type="skype" style={iconStyle} />,

    <Icon type="qq" style={iconStyle} />,
    <Icon type="medium-workmark" style={iconStyle} />,
    <Icon type="gitlab" style={iconStyle} />,
    <Icon type="medium" style={iconStyle} />,
    <Icon type="linkedin" style={iconStyle} />,
    <Icon type="google-plus" style={iconStyle} />,

    <Icon type="dropbox" style={iconStyle} />,
    <Icon type="facebook" style={iconStyle} />,
    <Icon type="codepen" style={iconStyle} />,
    <Icon type="amazon" style={iconStyle} />,
    <Icon type="google" style={iconStyle} />,
    <Icon type="codepen-circle" style={iconStyle} />,

    <Icon type="alipay" style={iconStyle} />,
    <Icon type="ant-design" style={iconStyle} />,
    <Icon type="aliyun" style={iconStyle} />,
    <Icon type="zhihu" style={iconStyle} />,
    <Icon type="slack" style={iconStyle} />,
    <Icon type="slack-square" style={iconStyle} />,

    <Icon type="behance" style={iconStyle} />,
    <Icon type="behance-square" style={iconStyle} />,
    <Icon type="dribbble" style={iconStyle} />,
    <Icon type="dribbble-square" style={iconStyle} />,
    <Icon type="instagram" style={iconStyle} />,
    <Icon type="yuque" style={iconStyle} />,
];


class Sgi_IconShow extends React.Component {

    static defaultProps = {
    };  // 注意这里有分号
    static propTypes = {
    };  // 注意这里有分号

    constructor(props) {
        super(props);
    }

    onClick = (item) => {
        console.log("类型",item.props.type);
    }

    // 生成
    fitCardItems = (data) => data.map((item) => {
        return (
            <Card.Grid key={item.props.type} style={gridStyle} onClick={this.onClick.bind(this,item)}>
                {item}<br/><br/>
                <span>{item.props.type}</span>
            </Card.Grid>
        );
    });

    //渲染并返回一个虚拟DOM
    render = function () {

        if (!this.loaded) {
            this.loaded = true;
        }

        return (
            <div>
                <Card title="方向性图标" >
                    {this.fitCardItems(Directional_Icons)}
                </Card>
                <Card title="提示建议性图标" >
                    {this.fitCardItems(Suggested_Icons)}
                </Card>
                <Card title="网站通用图标" >
                    {this.fitCardItems(Application_Icons)}
                </Card>
                <Card title="品牌和标识" >
                    {this.fitCardItems(Brand_and_Logos)}
                </Card>
            </div>
        );
    }
}

export { Sgi_IconShow };
