import React from 'react'
import { Link } from 'react-router'
//import { List, Card } from 'antd';
import { Menu, Row, Col, Dropdown, Button, Icon, message, Modal, Tree, Card, Radio } from 'antd';
const TreeNode = Tree.TreeNode;
import { Layout, Breadcrumb, Collapse, Input, Tooltip, Affix } from 'antd';
const { Header, Content, Footer, Sider } = Layout;
const Panel = Collapse.Panel;
import { browserHistory } from 'react-router'
const SubMenu = Menu.SubMenu;
const MenuItemGroup = Menu.ItemGroup;
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd';
import { AllCompGUID } from '../sgiComp/SgiCompConstant';
const ButtonGroup = Button.Group;




import { DragDropContextProvider, DragDropContext } from 'react-dnd'
import HTML5Backend from 'react-dnd-html5-backend'
import Dustbin from './Dustbin'
import Box from './Box'
import Dnd_Button from './Dnd_Button'
import Dnd_SgiButton from './Dnd_SgiButton'
import * as DndDispatch from './DndDispatch'
import { SgiUCVEO } from '../sgiCompEO/SgiUCVEO'
// import { sgiLocalStorage } from "../sgiFactory/localStorage"
import { uuid, copy, jsonToStr, copyArr } from "../sgiCommon/sgiCommon";
import Dnd_SgiMainComp from './Dnd_SgiMainComp';
import { SgiMainComp } from '../sgiComp/SgiMainComp'
import { ObjFactory } from '../sgiFactory/ObjFactory'
import { PrmFactory } from '../sgiFactory/PrmFactory';
import * as sgiDndDevComFun from './sgiDndDevComFun';

const style = {
    height: '100%',
    width: '100%',
    marginRight: '2px',
    marginBottom: '2px',
    // color: 'white',
    // padding: '2px',
    // textAlign: 'center',
    // fontSize: '1rem',
    // lineHeight: 'normal',
    // float: 'left',
    // border: '1px dashed grey'
}

// let refFuntion = (input) => {
//     console.log(this);
//     console.log(input);
//     console.log(arguments);
// }

let guid = 'rnt_UI_webTest_wz01';
let lastSelModule;
// let guid = 'rnt_UI_webTest_0004-bak';

class Container extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            loading: false,
            desid: '',
            sonItems: this.props.children ? this.props.children : [],
            moduleDesc: {},
            guid: this.props.guid ? this.props.guid : guid,
            visible: false, //弹出框默认不显示
            modal_title: '编辑', //弹出框的标题
            modal_context: <div>编辑内容</div>,
            activeKey: '',
            CurrentSelMoudleguid: '',
            CurrentSelMoudlete: '',
            // expandedKeys: [],
            expandedKeys: ['0-0'],

            devMode: 'dev', //开发模式  开发和预览
            treeCollapsed: false //树结构收缩
        };
        this.initDndDevMain();
    }

    initDndDevMain() {
        let guid = this.state.guid;
        let ucvData = PrmFactory.getPrm(this.state.guid);
        //使用老平台开发的时候，缺少dnd_id，补充dnd_id
        DndDispatch.fitUIJsonDndID(ucvData.cldSet);
        //初始化rootchild 这个数据是最终存储数据
        DndDispatch.initRootChildren(copy(ucvData.cldSet, true));
        //初始化显示
        this.state.sonItems = DndDispatch.initDndDevMain(ucvData.cldSet, this);
        delete ucvData.cldSet;
        this.state.moduleDesc = ucvData;
    }

    createNewUI() {
        let ucv = SgiUCVEO();
        ucv.ap = 'test';
        ucv.tt = 'test';
        ucv.ss = 'test';
        ucv.sc = 'test';
        ucv.prmVsn = 0;
        this.state.moduleDesc = ucv;
        DndDispatch.initRootChildren([]);
        this.setState({ sonItems: [] });
    }

    saveUI() {
        let rootChild = DndDispatch.getRootChildren();
        let uijson = this.state.moduleDesc;
        uijson.cldSet = rootChild;
        let newParm = PrmFactory.save(uijson);
        if (newParm.prmVsn) {
            uijson.prmVsn = newParm.prmVsn;
        }
        delete uijson.cldSet;
    }

    handleCancel = () => {
        this.setState({ visible: false });
    }

    openModal = () => {
        this.setState({ visible: true });
    }

    collapseOnChange = (key) => {
        this.setState({ activeKey: key });
    }


    editorModule = () => {
        let mainUI = DndDispatch.getMainUI();
        mainUI.openModal();
    }

    moveUpModule = () => {
        let parentModule = DndDispatch.getCurrentSelPraentMoudle();
        let module = DndDispatch.getCurrentSelMoudle();
        console.log(module);
    }

    moveDownModule = () => {
        let parentModule = DndDispatch.getCurrentSelPraentMoudle();
        let module = DndDispatch.getCurrentSelMoudle();
        console.log(module);
    }

    deleteModule = () => {

        let parentModule = DndDispatch.getCurrentSelPraentMoudle();
        let module = DndDispatch.getCurrentSelMoudle();
        //删除页面中选中的
        let sonItems;
        let dataSonItems;
        let dataItem;
        if (!parentModule) {
            message.success("根节点不能删除", 3);
            return;
        } else if (!parentModule.props.moduleDesc || !parentModule.props.moduleDesc.dnd_id) {
            parentModule = this.refs.Dnd_SgiMainComp_SgiMainComp;
            sonItems = this.state.sonItems;
            dataSonItems = DndDispatch.getRootChildren();
        } else {
            parentModule = DndDispatch.getShowModule(parentModule.props.moduleDesc.dnd_id);
            // parentModule = parentModule.handler.component;//有一层拖拽结构
            sonItems = parentModule.state.sonItems;
            dataItem = DndDispatch.findNodeByDndID(undefined, parentModule.props.moduleDesc.dnd_id);
            dataSonItems = dataItem.cldSet;
        }
        this.deleteShowModule(sonItems, module.props.moduleDesc);
        // parentModule.state.sonItems = copyArr(sonItems);
        //删除数据中的选中值
        let dataModule = DndDispatch.findNodeByDndID(undefined, module.props.moduleDesc.dnd_id);
        this.deleteDataModule(dataSonItems, dataModule);

        if (parentModule.handler && parentModule.handler.component) {
            parentModule.handler.component.refresh();
        }
        if (parentModule.refresh) {
            parentModule.refresh();
        }
    }

    deleteDataModule(sonItems, moduleDesc) {
        if (!sonItems || sonItems.length == 0) {
            return;
        }
        if (!moduleDesc || !moduleDesc.dnd_id) {
            return;
        }
        for (var i = 0; i < sonItems.length; i++) {
            var tmp = sonItems[i];
            if (typeof tmp == "object") {
                if (tmp.dnd_id === moduleDesc.dnd_id) {
                    sonItems.splice(i, 1);
                }
            }
        }
    }

    deleteShowModule(sonItems, moduleDesc) {
        if (!sonItems || sonItems.length == 0) {
            return;
        }
        if (!moduleDesc || !moduleDesc.dnd_id) {
            return;
        }
        for (var i = 0; i < sonItems.length; i++) {
            var tmp = sonItems[i];
            if (typeof tmp == "object") {
                if (tmp.props.moduleDesc && tmp.props.moduleDesc.dnd_id === moduleDesc.dnd_id) {
                    // sonItems.splice(i, 1); //剔除的话没用，导致刷新删除永远是最后一个，感觉这是react的bug
                    sonItems[i] = <div></div>; //改成空吧
                }
            }
        }
    }

    refresh() {
        this.setState({ loading: false });
    }

    renderTreeNodes = (data) => {
        return data.map((item) => {
            if (item.cldSet) {
                return (
                    <TreeNode title={item.ctlN + "_" + (item.te || item.n || '未命名')} key={item.dnd_id}>
                        {this.renderTreeNodes(item.cldSet)}
                    </TreeNode>
                );
            }
            // this.state.expandedKeys.push(item.dnd_id);
            return <TreeNode title={item.ctlN + "_" + (item.te || item.n || '未命名')} key={item.dnd_id} />;
        });
    }

    onTreeSelect = (selectedKeys, info) => {
        console.log('onSelect', info);
        let showModule;
        if (selectedKeys.length == 1 && selectedKeys[0] != '0-0') { //选择普通节点的时候
            showModule = DndDispatch.getShowModule(selectedKeys[0]);
            // } else if (selectedKeys.length == 0) { //选择根节点的时候
        } else { //选择根节点的时候
            showModule = DndDispatch.getMainUI();
            showModule = showModule.refs['Dnd_SgiMainComp_SgiMainComp'];
            showModule = showModule.handler.component;
        }

        if (lastSelModule) {
            sgiDndDevComFun.toggleHoverLeave(lastSelModule);
        }

        if (!showModule) {
            message.error("该面板还没有渲染（tab、折叠、层叠下面板有这个问题），无法切换到该面板上，这个问题努力修复中", 3);
            return;
        }
        sgiDndDevComFun.toggleHover(showModule);
        sgiDndDevComFun.onClick(showModule);
        lastSelModule = showModule;

        // this.setState({ selectedKeys });
    }

    handleModeChange = (e) => {

        let value = e.target.value;
        if (!value) {
            return;
        }

        if (value == 'dev') {
            let showTreeData = this.state.moduleDesc;
            delete showTreeData.cldSet;
        } else {
            let showTreeData = this.state.moduleDesc;
            showTreeData.cldSet = DndDispatch.getRootChildren();
            this.refs['SgiMainComp_SgiMainComp'].refresh();
        }

        this.setState({ devMode: e.target.value });
    }

    onCollapse = (collapsed) => {
        // console.log(collapsed);
        this.setState({ treeCollapsed: collapsed });
    }

    onTreeExpand = (expandedKeys) => {
        console.log('onExpand', arguments);
        // if not set autoExpandParent to false, if children expanded, parent can not collapse.
        // or, you can remove all expanded children keys.
        this.setState({
            expandedKeys
            // autoExpandParent: false,
        });
    }

    render() {

        const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
        const isActive = isOverCurrent;

        let backgroundColor = ''
        if (isActive) {
            backgroundColor = 'darkgreen'
        } else if (canDrop) {
            backgroundColor = 'darkkhaki'
        }

        // this.state.

        let preobjFct;
        if (this.props.objFct) {
            preobjFct = this.props.objFct;
        } else {
            preobjFct = new ObjFactory(this.state.guid);
        }
        let previewInfo = <SgiMainComp objFct={preobjFct} ref={'SgiMainComp_SgiMainComp'} moduleDesc={this.state.moduleDesc}></SgiMainComp>

        let editorInfo =
            <Layout style={{ width: '100%', height: '100%' }}>

                <Content>
                    <Row style={{ width: '100%', height: '100%' }}>
                        <Col span={20} style={{ height: '100%' }}>
                            {connectDropTarget(
                                <div style={{ ...style, backgroundColor }}>
                                    <Dnd_SgiMainComp ref={'Dnd_SgiMainComp_SgiMainComp'} moduleDesc={this.state.moduleDesc} modal_context={'Dnd_SgiMainCompEditor'}
                                        modal_title={'UCV编辑'} type={'dnd'} objFct={this.props.objFct}>
                                        {this.state.sonItems}
                                    </Dnd_SgiMainComp>
                                </div>
                            )}
                        </Col>
                        <Col span={4} style={{ height: '100%' }}>
                            {/* <Button type="primary" style={{ margin: '1px 1px 1px 1px' }} onClick={this.createNewUI.bind(this)}>新建</Button> */}
                            <Button type="primary" style={{ margin: '1px 1px 1px 1px' }} onClick={this.saveUI.bind(this)}>保存</Button>
                            <Collapse accordion defaultActiveKey={"1"} activeKey={this.state.activeKey} onChange={this.collapseOnChange.bind(this)}>
                                <Panel header="栅格组件" key="1">
                                    <Dnd_Button name="24" type='row24' desId={AllCompGUID.LT_ROW} />
                                    <Dnd_Button name="12+12" type='row12+12' desId={AllCompGUID.LT_ROW} />
                                    <Dnd_Button name="8+8+8" type='row8+8+8' desId={AllCompGUID.LT_ROW} />
                                    <Dnd_Button name="6+6+6+6" type='row6+6+6+6' desId={AllCompGUID.LT_ROW} />
                                    <Dnd_Button name="16+8" type='row16+8' desId={AllCompGUID.LT_ROW} />
                                    <Dnd_Button name="4+12+8" type='row4+12+8' desId={AllCompGUID.LT_ROW} />
                                </Panel>
                                <Panel header="容器组件" key="2">
                                    <Dnd_Button name="选项卡" desId={AllCompGUID.TAB} />
                                    <Dnd_Button name="普通面板" desId={AllCompGUID.PANEL} />
                                    <Dnd_Button name="分割面板" desId={AllCompGUID.SPLITTER} />
                                    <Dnd_Button name="重叠面板" desId={AllCompGUID.CARD} />
                                    <Dnd_Button name="折叠面板" desId={AllCompGUID.ACCORDION} />
                                    <Dnd_Button name="嵌入面板" desId={AllCompGUID.NEST} />
                                </Panel>
                                <Panel header="表单容器和表单组件" key="3">
                                    <Dnd_Button name="form控件" desId={AllCompGUID.WV} />
                                    <Dnd_Button name="文本框" desId={AllCompGUID.FIELDTEXT} />
                                    <Dnd_Button name="文本域" desId={AllCompGUID.TEXTAREA} />
                                    <Dnd_Button name="数字控件" desId={AllCompGUID.NUMBER} />
                                    <Dnd_Button name="日期控件" desId={AllCompGUID.DATE} />
                                    <Dnd_Button name="时间控件" desId={AllCompGUID.TIME} />
                                    <Dnd_Button name="文件控件" desId={AllCompGUID.UPLOADFILE} />
                                    <Dnd_Button name="下拉框控件" desId={AllCompGUID.COMBOBOX} />
                                    <Dnd_Button name="复选框控件" desId={AllCompGUID.CHECKBOX} />
                                    <Dnd_Button name="复选框组控件" desId={AllCompGUID.CHECKBOXGROUP} />
                                    <Dnd_Button name="单选框组控件" desId={AllCompGUID.RADIOGROUP} />
                                    <Dnd_Button name="弹出框控件" desId={AllCompGUID.POPUI} />
                                    <Dnd_Button name="富文本控件" desId={AllCompGUID.EDITOR} />
                                    <Dnd_Button name="下拉树控件" desId={AllCompGUID.COMBOXTREE} />
                                </Panel>
                                <Panel header="普通组件" key="4">
                                    <Dnd_Button name="工具条" desId={AllCompGUID.TOOLBAR} />
                                    <Dnd_Button name="按钮" desId={AllCompGUID.BUTTON} />
                                    <Dnd_Button name="图片" desId={AllCompGUID.IMG} />
                                </Panel>
                                <Panel header="表格和树" key="5">
                                    <Dnd_Button name="表格" desId={AllCompGUID.TABLE} />
                                    <Dnd_Button name="树" desId={AllCompGUID.TREE} />
                                </Panel>
                                <Panel header="导航组件" key="6">
                                    <Dnd_Button name="步骤" desId={AllCompGUID.STEP} />
                                    <Dnd_Button name="menu" desId={AllCompGUID.MENU} />
                                </Panel>
                            </Collapse>
                        </Col>
                    </Row>
                </Content>

                <Sider collapsible collapsed={this.state.treeCollapsed}
                    onCollapse={this.onCollapse.bind(this)} style={{ background: '#fff', overflow: "auto" }}>
                    {/* <Col span={4} style={{ height: '100%' }}> */}
                    {/* <Card title="选中组件编辑"> */}
                    <div style={{ border: '1px grey', width: '200px' }}>
                        <p style={{ margin: '0 0 5px 1px' }}>选中组件编辑</p>
                        <Row>
                            <Col span={24}>
                                <Input value={this.state.CurrentSelMoudleguid} disabled />
                            </Col>
                        </Row>
                        <Row>
                            <Col span={24}>
                                <Input value={this.state.CurrentSelMoudlete} disabled />
                            </Col>
                        </Row>
                        <Row>
                            <Button type="primary" style={{ margin: '2px 1px 1px 1px' }} onClick={this.editorModule.bind(this)}>编辑</Button>
                            <Button type="danger" style={{ margin: '2px 1px 1px 1px' }} onClick={this.deleteModule.bind(this)}>删除</Button>
                        </Row>
                        <Button type="" style={{ margin: '2px 1px 1px 1px' }} onClick={this.moveUpModule.bind(this)}>上移</Button>
                        <Button type="" style={{ margin: '2px 1px 1px 1px' }} onClick={this.moveDownModule.bind(this)}>下移</Button>
                    </div>
                    {/* </Card> */}
                    <p style={{ margin: '10px 0 0 1px' }}>组件结构树</p>
                    <Tree
                        showLine
                        // checkable
                        onExpand={this.onTreeExpand}
                        expandedKeys={this.state.expandedKeys}
                        autoExpandParent={true}
                        // onCheck={this.onCheck}
                        // checkedKeys={this.state.checkedKeys}
                        onSelect={this.onTreeSelect}
                    // selectedKeys={this.state.selectedKeys}
                    >
                        <TreeNode title={this.state.moduleDesc.ctlN + "_" + (this.state.moduleDesc.te || this.state.moduleDesc.n || '未命名')} key={'0-0'}>
                            {this.renderTreeNodes(DndDispatch.getRootChildren())}
                        </TreeNode>
                    </Tree>
                    {/* </Col> */}
                </Sider>
            </Layout>

        return (
            <div style={{ width: '100%', height: '100%' }}>

                {/* <Sider width={'60px'}>
                    <Radio.Group style={{ margin: '200px 1px 1px 1px' }} value={this.state.devMode} onChange={this.handleModeChange.bind(this)}>
                        <Row>
                            <Tooltip title='开发模式' mouseLeaveDelay={0}>
                                <Radio.Button value="dev"><Icon type="edit" /></Radio.Button>
                            </Tooltip>
                        </Row>
                        <Row>
                            <Tooltip title='预览模式' mouseLeaveDelay={0}>
                                <Radio.Button value="prev"><Icon type="laptop" /></Radio.Button>
                            </Tooltip>
                        </Row>
                    </Radio.Group>
                </Sider> */}
                {/* <Content> */}
                <div style={{ display: (this.state.devMode == 'dev' ? undefined : "none"), width: '100%', height: '100%' }}>
                    {editorInfo}</div>
                <div style={{ display: (this.state.devMode == 'dev' ? "none" : undefined), width: '100%', height: '100%' }}>
                    {previewInfo}</div>
                <Affix style={{ position: 'absolute', top: '10px', right: '10px' }}>
                    <Radio.Group style={{ margin: '150px 1px 1px 1px' }} value={this.state.devMode} onChange={this.handleModeChange.bind(this)}>
                        <Row>
                            <Tooltip title='开发模式' mouseLeaveDelay={0}>
                                <Radio.Button value="dev"><Icon type="edit" /></Radio.Button>
                            </Tooltip>
                        </Row>
                        <Row>
                            <Tooltip title='预览模式' mouseLeaveDelay={0}>
                                <Radio.Button value="prev"><Icon type="laptop" /></Radio.Button>
                            </Tooltip>
                        </Row>
                    </Radio.Group>
                </Affix>
                {/* </Content> */}

                <Modal
                    title={this.state.modal_title}
                    visible={this.state.visible}
                    onCancel={this.handleCancel}
                    width='1000px'
                    height='800px'
                    footer={null}
                >
                    {this.state.modal_context}
                </Modal>

            </div>
        )
    }
    componentDidMount = function () {
        DndDispatch.initMainUI(this);
    }
}

const boxTarget = {
    drop(props, monitor, Component) {
        DndDispatch.dropTarget(props, monitor, Component);
    }
}

var collect = (connect, monitor) => ({
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver(),
    canDrop: monitor.canDrop(),
    isOverCurrent: monitor.isOver({ shallow: true }),
})

let ContainerTarget = DropTarget('enter', boxTarget, collect)(Container)

export default DragDropContext(HTML5Backend)(ContainerTarget);