import React from 'react'
import Dnd_SgiRow from './Dnd_SgiRow';
import Dnd_SgiCol from './Dnd_SgiCol';
import Dnd_SgiTabs from './Dnd_SgiTabs'
import Dnd_SgiPanel from './Dnd_SgiPanel'
import Dnd_SgiForm from './Dnd_SgiForm'
import Dnd_SgiCollapse from './Dnd_SgiCollapse'
import Dnd_SgiSplitter from './Dnd_SgiSplitter'
import Dnd_SgiNest from './Dnd_SgiNest'
import Dnd_SgiTable from './Dnd_SgiTable'
import Dnd_SgiTree from './Dnd_SgiTree'
import Dnd_SgiButton from './Dnd_SgiButton'
import Dnd_SgiToolbar from './Dnd_SgiToolbar'
import Dnd_SgiFormText from './Dnd_SgiFormText'
import Dnd_SgiFormTextArea from './Dnd_SgiFormTextArea'
import Dnd_SgiFormNumber from './Dnd_SgiFormNumber'
import Dnd_SgiFormDate from './Dnd_SgiFormDate'
import Dnd_SgiFormTime from './Dnd_SgiFormTime'
import Dnd_SgiFormFile from './Dnd_SgiFormFile'
import Dnd_SgiFormCombobox from './Dnd_SgiFormCombobox'
import Dnd_SgiFormCheckbox from './Dnd_SgiFormCheckbox'
import Dnd_SgiFormCheckboxGroup from './Dnd_SgiFormCheckboxGroup'
import Dnd_SgiFormRadio from './Dnd_SgiFormRadio'
import Dnd_SgiFormPopUI from './Dnd_SgiFormPopUI'
import Dnd_SgiFormEditorE from './Dnd_SgiFormEditorE';
import Dnd_SgiFormComboxTree from './Dnd_SgiFormComboxTree';
import { AllCompGUID } from '../sgiComp/SgiCompConstant'
import { SgiRow } from '../sgiLayout/SgiRow';
import { SgiRowEO } from '../sgiCompEO/SgiRowEO'
import { SgiCol } from '../sgiLayout/SgiCol';
import { SgiColEO } from '../sgiCompEO/SgiColEO'
import { SgiFormText } from '../sgiComp/SgiFormText'
import { SgiFormTextEO } from '../sgiCompEO/SgiFormTextEO'
import { SgiFormTextAreaEO } from '../sgiCompEO/SgiFormTextAreaEO'
import { SgiFormInputNumberEO } from '../sgiCompEO/SgiFormInputNumberEO'
import { SgiFormDateEO } from '../sgiCompEO/SgiFormDateEO'
import { SgiFormTimeEO } from '../sgiCompEO/SgiFormTimeEO'
import { SgiFormFileEO } from '../sgiCompEO/SgiFormFileEO'
import { SgiFormComboboxEO } from '../sgiCompEO/SgiFormComboboxEO'
import { SgiFormCheckboxEO } from '../sgiCompEO/SgiFormCheckboxEO'
import { SgiFormCheckboxGroupEO } from '../sgiCompEO/SgiFormCheckboxGroupEO'
import { SgiFormRadioEO } from '../sgiCompEO/SgiFormRadioEO'
import { SgiFormPopUIEO } from '../sgiCompEO/SgiFormPopUIEO'
import { SgiFormEditorEO } from '../sgiCompEO/SgiFormEditorEO';
import { SgiFormComboxTreeEO } from '../sgiCompEO/SgiFormComboxTreeEO';
import { SgiCard } from '../sgiComp/SgiCard'
import { SgiCardEO } from '../sgiCompEO/SgiCardEO'
import { SgiTabsEO } from '../sgiCompEO/SgiTabsEO'
import { SgiCollapseEO } from '../sgiCompEO/SgiCollapseEO'
import { SgiSplitterEO } from '../sgiCompEO/SgiSplitterEO'
import { SgiPanel } from '../sgiComp/SgiPanel'
import { SgiPanelEO } from '../sgiCompEO/SgiPanelEO'
import { SgiFormEO } from '../sgiCompEO/SgiFormEO'
import { SgiNestEO } from '../sgiCompEO/SgiNestEO'
import { SgiTableEO } from '../sgiCompEO/SgiTableEO'
import { SgiTreeEO } from '../sgiCompEO/SgiTreeEO'
import { SgiButtonEO } from '../sgiCompEO/SgiButtonEO'
import { SgiToolbarEO } from '../sgiCompEO/SgiToolbarEO'
import { uuid, copy, jsonToStr } from "../sgiCommon/sgiCommon";



let RootChildren = []; //当前只能有一个控件使用这个数据
let allShowModule = {}; //存储所有显示组件
let currentSelMoudle, currentSelParentMoudle;
let MainUI;
// let map = {};
let mkType = 'dnd';

let getShowModule = function (dnd_id) {
    if (!dnd_id) {
        return null;
    }
    return allShowModule[dnd_id];
}

let setCurrentSelMoudle = function (module) {
    currentSelMoudle = module;
}

let getCurrentSelMoudle = function () {
    return currentSelMoudle;
}

let setCurrentSelPraentMoudle = function (module) {
    currentSelParentMoudle = module;
}

let getCurrentSelPraentMoudle = function () {
    return currentSelParentMoudle;
}

let refFuntion = (ctl) => {
    if (!ctl) {
        return;
    }
    let dnd_id = ctl.props.moduleDesc.dnd_id;
    if (ctl && ctl.handler && ctl.handler.component) {//有一层拖拽结构 目前只有col有嵌套了
        allShowModule[dnd_id] = ctl.handler.component;
    } else {
        allShowModule[dnd_id] = ctl;
    }
}

let initMainUI = function (mainUI) {
    MainUI = mainUI;
}

let getMainUI = function () {
    return MainUI;
}

let initRootChildren = function (rootChildren) {
    if (!rootChildren) {
        rootChildren = [];
    }
    RootChildren = rootChildren;
}

let getRootChildren = function () {
    return RootChildren;
}

let dropTarget = function (props, monitor, Component) {
    const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = Component.props
    // const isActive = isOverCurrent;

    // console.log('isOverCurrent', isOverCurrent);
    //拖拽目的地
    if (!isOverCurrent) {
        return;
    }

    let dragItem = monitor.getItem();

    let sonItems = Component.state.sonItems;
    let sgiCompDesc;

    let { type, desId } = dragItem;

    //文本框
    if (desId && desId == AllCompGUID.FIELDTEXT) {
        sgiCompDesc = SgiFormTextEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //文本域    
    } else if (desId && desId == AllCompGUID.TEXTAREA) {
        sgiCompDesc = SgiFormTextAreaEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //数字控件    
    } else if (desId && desId == AllCompGUID.NUMBER) {
        sgiCompDesc = SgiFormInputNumberEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //日期控件    
    } else if (desId && desId == AllCompGUID.DATE) {
        sgiCompDesc = SgiFormDateEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //时间控件    
    } else if (desId && desId == AllCompGUID.TIME) {
        sgiCompDesc = SgiFormTimeEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //文件控件    
    } else if (desId && desId == AllCompGUID.UPLOADFILE) {
        sgiCompDesc = SgiFormFileEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //下拉窗控件    
    } else if (desId && desId == AllCompGUID.COMBOBOX) {
        sgiCompDesc = SgiFormComboboxEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //复选框控件    
    } else if (desId && desId == AllCompGUID.CHECKBOX) {
        sgiCompDesc = SgiFormCheckboxEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //复选框组件    
    } else if (desId && desId == AllCompGUID.CHECKBOXGROUP) {
        sgiCompDesc = SgiFormCheckboxGroupEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //单选框组件    
    } else if (desId && desId == AllCompGUID.RADIOGROUP) {
        sgiCompDesc = SgiFormRadioEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //弹出窗控件    
    } else if (desId && desId == AllCompGUID.POPUI) {
        sgiCompDesc = SgiFormPopUIEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //富文本控件    
    } else if (desId && desId == AllCompGUID.EDITOR) {
        sgiCompDesc = SgiFormEditorEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //下拉树控件    
    } else if (desId && desId == AllCompGUID.COMBOXTREE) {
        sgiCompDesc = SgiFormComboxTreeEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //Dnd_SgiToolbar
    } else if (desId && desId == AllCompGUID.TOOLBAR) {
        sgiCompDesc = SgiToolbarEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //Dnd_SgiButton
    } else if (desId && desId == AllCompGUID.BUTTON) {
        sgiCompDesc = SgiButtonEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //树面板
    } else if (desId && desId == AllCompGUID.TREE) {
        sgiCompDesc = SgiTreeEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //表格面板
    } else if (desId && desId == AllCompGUID.TABLE) {
        sgiCompDesc = SgiTableEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //嵌入面板
    } else if (desId && desId == AllCompGUID.NEST) {
        sgiCompDesc = SgiNestEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //form
    } else if (desId && desId == AllCompGUID.WV) {
        sgiCompDesc = SgiFormEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //panel
    } else if (desId && desId == AllCompGUID.PANEL) {
        sgiCompDesc = SgiPanelEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //重叠面板
    } else if (desId && desId == AllCompGUID.CARD) {
        sgiCompDesc = SgiCardEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //折叠面板
    } else if (desId && desId == AllCompGUID.ACCORDION) {
        sgiCompDesc = SgiCollapseEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //tab
    } else if (desId && desId == AllCompGUID.TAB) {
        sgiCompDesc = SgiTabsEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));
        //分割面板
    } else if (desId && desId == AllCompGUID.SPLITTER) {
        sgiCompDesc = SgiSplitterEO();
        sgiCompDesc.dnd_id = 'id_' + uuid(8);
        sonItems.push(DndDispatch(desId, sgiCompDesc, Component));

        //布局这个比较特殊，单独处理json结构
    } else if (desId && desId == AllCompGUID.LT_ROW) {
        if (type && type === 'row24') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc = SgiColEO();
            sgicolDesc.span = 24;
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc.dnd_id = 'id_' + uuid(8);
            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);
            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc} parentModule={Component}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc, sgirowDesc.dnd_id);
        } else if (type && type === 'row12+12') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc1 = SgiColEO();
            let sgicolDesc2 = SgiColEO();
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.dnd_id = 'id_' + uuid(8);
            sgicolDesc2.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.span = 12;
            sgicolDesc2.span = 12;

            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc1, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc2, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);
            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc1)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc2)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc1, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc2, sgirowDesc.dnd_id);
        } else if (type && type === 'row16+8') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc1 = SgiColEO();
            let sgicolDesc2 = SgiColEO();
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.dnd_id = 'id_' + uuid(8);
            sgicolDesc2.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.span = 16;
            sgicolDesc2.span = 8;

            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc1, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc2, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);

            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc1)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc2)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc1, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc2, sgirowDesc.dnd_id);
        } else if (type && type === 'row8+8+8') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc1 = SgiColEO();
            let sgicolDesc2 = SgiColEO();
            let sgicolDesc3 = SgiColEO();
            sgicolDesc1.span = 8;
            sgicolDesc2.span = 8;
            sgicolDesc3.span = 8;
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.dnd_id = 'id_' + uuid(8);
            sgicolDesc2.dnd_id = 'id_' + uuid(8);
            sgicolDesc3.dnd_id = 'id_' + uuid(8);

            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc1, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc2, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc3, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);

            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc1)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc2)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc3)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc1, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc2, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc3, sgirowDesc.dnd_id);
        } else if (type && type === 'row4+12+8') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc1 = SgiColEO();
            let sgicolDesc2 = SgiColEO();
            let sgicolDesc3 = SgiColEO();
            sgicolDesc1.span = 4;
            sgicolDesc2.span = 12;
            sgicolDesc3.span = 8;
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.dnd_id = 'id_' + uuid(8);
            sgicolDesc2.dnd_id = 'id_' + uuid(8);
            sgicolDesc3.dnd_id = 'id_' + uuid(8);

            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc1, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc2, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc3, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);

            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc1)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc2)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc3)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc1, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc2, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc3, sgirowDesc.dnd_id);
        } else if (type && type === 'row6+6+6+6') {
            let sgirowDesc = SgiRowEO();
            let sgicolDesc1 = SgiColEO();
            let sgicolDesc2 = SgiColEO();
            let sgicolDesc3 = SgiColEO();
            let sgicolDesc4 = SgiColEO();
            sgicolDesc1.span = 6;
            sgicolDesc2.span = 6;
            sgicolDesc3.span = 6;
            sgicolDesc4.span = 6;
            sgirowDesc.dnd_id = 'id_' + uuid(8);
            sgicolDesc1.dnd_id = 'id_' + uuid(8);
            sgicolDesc2.dnd_id = 'id_' + uuid(8);
            sgicolDesc3.dnd_id = 'id_' + uuid(8);
            sgicolDesc4.dnd_id = 'id_' + uuid(8);

            // let dndRow = <Dnd_SgiRow ref={refFuntion} moduleDesc={sgirowDesc} type={mkType} parentModule={Component} />;
            let dndRow = DndDispatch(AllCompGUID.LT_ROW, sgirowDesc, Component);
            let dndColArray = [];
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc1, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc2, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc3, dndRow));
            dndColArray.push(DndDispatch(AllCompGUID.LT_COL, sgicolDesc4, dndRow));
            dndRow.props.sonItems = dndColArray;
            sonItems.push(dndRow);

            // sonItems.push(<Dnd_SgiRow moduleDesc={sgirowDesc}>
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc1)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc2)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc3)}
            //     {DndDispatch(AllCompGUID.LT_COL, sgicolDesc4)}
            // </Dnd_SgiRow>);
            fitUIJson(RootChildren, Component.state.moduleDesc, sgirowDesc);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc1, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc2, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc3, sgirowDesc.dnd_id);
            fitUIJson(RootChildren, sgirowDesc, sgicolDesc4, sgirowDesc.dnd_id);
        }
    }


    //除了row布局其他都用这个添加结构
    fitUIJson(RootChildren, Component.state.moduleDesc, sgiCompDesc);

}


/**
 * 根据不同类型返回 拖拽组件
 * @param {唯一标示} desId 
 * @param {*} props 
 */
let DndDispatch = function (desId, sgiCompDesc, Component) {
    if (!desId || !sgiCompDesc) {
        return;
    }
    let module;
    //文本框
    if (desId && desId == AllCompGUID.FIELDTEXT) {
        module = <Dnd_SgiFormText moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormTextEditor'}
            modal_title={'文本框编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //文本域
    } else if (desId && desId == AllCompGUID.TEXTAREA) {
        module = <Dnd_SgiFormTextArea moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormTextAreaEditor'}
            modal_title={'文本域编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //数字控件
    } else if (desId && desId == AllCompGUID.NUMBER) {
        module = <Dnd_SgiFormNumber moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormNumberEditor'}
            modal_title={'数字控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //日期控件
    } else if (desId && desId == AllCompGUID.DATE) {
        module = <Dnd_SgiFormDate moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormDateEditor'}
            modal_title={'日期控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //时间控件
    } else if (desId && desId == AllCompGUID.TIME) {
        module = <Dnd_SgiFormTime moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormTimeEditor'}
            modal_title={'时间控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //文件控件
    } else if (desId && desId == AllCompGUID.UPLOADFILE) {
        module = <Dnd_SgiFormFile moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormFileEditor'}
            modal_title={'文件控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //下拉窗控件
    } else if (desId && desId == AllCompGUID.COMBOBOX) {
        module = <Dnd_SgiFormCombobox moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormComboboxEditor'}
            modal_title={'下拉窗控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //复选框控件
    } else if (desId && desId == AllCompGUID.CHECKBOX) {
        module = <Dnd_SgiFormCheckbox moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormCheckboxEditor'}
            modal_title={'复选框控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //复选框组件
    } else if (desId && desId == AllCompGUID.CHECKBOXGROUP) {
        module = <Dnd_SgiFormCheckboxGroup moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormCheckboxGroupEditor'}
            modal_title={'复选框组件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //单选框组件
    } else if (desId && desId == AllCompGUID.RADIOGROUP) {
        module = <Dnd_SgiFormRadio moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormRadioEditor'}
            modal_title={'单选框组件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //弹出窗控件
    } else if (desId && desId == AllCompGUID.POPUI) {
        module = <Dnd_SgiFormPopUI moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormPopUIEditor'}
            modal_title={'弹出窗控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //富文本控件
    } else if (desId && desId == AllCompGUID.EDITOR) {
        module = <Dnd_SgiFormEditorE moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormEditorEditor'}
            modal_title={'富文本控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //下拉树控件
    } else if (desId && desId == AllCompGUID.COMBOXTREE) {
        module = <Dnd_SgiFormComboxTree moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormComboxTreeEditor'}
            modal_title={'富文本控件编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //Dnd_SgiToolbar
    } else if (desId && desId == AllCompGUID.TOOLBAR) {
        module = <Dnd_SgiToolbar moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiToolbarEditor'}
            modal_title={'工具条编辑'}
            comp_explain={'工具条组件,请拖入按钮'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //Dnd_SgiButton
    } else if (desId && desId == AllCompGUID.BUTTON) {
        module = <Dnd_SgiButton moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiButtonEditor'}
            modal_title={'按钮编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //tree
    } else if (desId && desId == AllCompGUID.TREE) {
        module = <Dnd_SgiTree moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiTreeEditor'}
            modal_title={'树编辑'}
            comp_explain={'树组件,不能再拖拽子组件，只能嵌入其他UI'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //table
    } else if (desId && desId == AllCompGUID.TABLE) {
        module = <Dnd_SgiTable moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiTableEditor'}
            modal_title={'表格编辑'}
            comp_explain={'表格组件,不能再拖拽子组件，只能嵌入其他UI'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //nest
    } else if (desId && desId == AllCompGUID.NEST) {
        module = <Dnd_SgiNest moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiNestEditor'}
            modal_title={'嵌入面板编辑'}
            comp_explain={'嵌入面板,不能再拖拽子组件，只能嵌入其他UI'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //panel
    } else if (desId && desId == AllCompGUID.PANEL) {
        module = <Dnd_SgiPanel moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiPanelEditor'}
            modal_title={'面板编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //form
    } else if (desId && desId == AllCompGUID.WV) {
        module = <Dnd_SgiForm moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiFormEditor'}
            modal_title={'FORM编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //重叠面板
    } else if (desId && desId == AllCompGUID.CARD) {
        module = <Dnd_SgiCollapse moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiCardEditor'}
            modal_title={'重叠面板编辑'}
            comp_explain={'重叠面板为了方便编辑，开发时使用折叠面板显示，请添加普通面板或FORM'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //折叠面板
    } else if (desId && desId == AllCompGUID.ACCORDION) {
        module = <Dnd_SgiCollapse moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiCollapseEditor'}
            modal_title={'折叠面板编辑'}
            comp_explain={'折叠组件,请拖入普通面板或FORM'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //tab
    } else if (desId && desId == AllCompGUID.TAB) {
        module = <Dnd_SgiTabs moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiTabsEditor'}
            modal_title={'选项卡编辑'}
            comp_explain={'tab组件,请拖入普通面板或FORM'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //分割面板
    } else if (desId && desId == AllCompGUID.SPLITTER) {
        module = <Dnd_SgiSplitter moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiSplitterEditor'}
            modal_title={'分割面板编辑'}
            comp_explain={'分割组件,请拖入普通面板或FORM'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
        //布局这个比较特殊，单独处理json结构
    } else if (desId && desId == AllCompGUID.LT_ROW) {
        module = <Dnd_SgiRow moduleDesc={sgiCompDesc}
            modal_context={'Dnd_SgiRowEditor'}
            modal_title={'row编辑'}
            ref={refFuntion}
            parentModule={Component}
            type={mkType} />
    } else if (desId && desId == AllCompGUID.LT_COL) {
        module = <Dnd_SgiCol moduleDesc={sgiCompDesc} modal_context={'Dnd_SgiColEditor'}
            modal_title={'col编辑'}
            parentModule={Component}
            ref={refFuntion}
            type={mkType} />
    }
    return module;
}

/**
 * 页面修改后，相应的数据修改
 * @param {当前修的组件的唯一标示} cnrrent_dnd_id 
 * @param {*} attname 
 * @param {*} value 
 */
var updateUIJson = function (cnrrent_dnd_id, attname, value) {
    let rootChildren = getRootChildren();
    let currentNode = findNodeByDndID(rootChildren, cnrrent_dnd_id);
    if (currentNode) {
        currentNode[attname] = value;
    }
}

/**
 * 拖拽页面后，将拖拽的信息放入到保存数据中
 * @param {*} rootChildren 
 * @param {*} moduleDesc 
 * @param {*} newCompDesc 
 * @param {*} up_dnd_id 
 */
var fitUIJson = function (rootChildren, moduleDesc, newCompDesc, up_dnd_id) {
    if (!newCompDesc) {
        return;
    }
    newCompDesc = copy(newCompDesc);
    // let moduleDesc = Component.state.moduleDesc;
    //不存在，就是根root，直接放到根root下
    if (!moduleDesc) {
        rootChildren.push(newCompDesc);
        return;
    }

    let dnd_id = up_dnd_id ? up_dnd_id : moduleDesc.dnd_id;
    //不存在，就是根root，直接放到根root下
    if (!dnd_id) {
        rootChildren.push(newCompDesc);
        return;
    }

    //在RootChildren中寻找dnd_id组件，将新组件放入到dnd
    let currentNode = findNodeByDndID(rootChildren, dnd_id);
    if (!currentNode.cldSet) {
        currentNode.cldSet = [];
    }
    currentNode.cldSet.push(newCompDesc);
}

var fitUIJsonDndID = function (rootChildren) {
    if (!rootChildren) {
        return;
    }
    for (let i = 0; i < rootChildren.length; i++) {
        let tmpNode = rootChildren[i];
        let dnd_id = tmpNode.dnd_id;
        if (!dnd_id) {
            tmpNode.dnd_id = 'id_' + uuid(8);;
        }
        if (tmpNode.cldSet && tmpNode.cldSet.length > 0) {
            fitUIJsonDndID(tmpNode.cldSet);
        }
    }
}

/**
 * 
 * @param {*} rootChildren 
 * @param {*} Component 父组件 
 */
var initDndDevMain = function (rootChildren, Component) {
    let sonItems = [];
    if (!rootChildren) {
        return;
    }
    for (let i = 0; i < rootChildren.length; i++) {
        let tmpNode = rootChildren[i];
        let desId = tmpNode.desId;
        let module = DndDispatch(desId, tmpNode, Component);
        sonItems.push(module);
        if (tmpNode.cldSet && tmpNode.cldSet.length > 0) {
            module.props.children = [];
            fitDndDevSons(module.props.children, tmpNode.cldSet, module);
            delete tmpNode.cldSet;
        }
    }
    return sonItems;
}

/**
 * 
 * @param {*} sonItems 
 * @param {*} cldSet 
 * @param {*} Component 父组件
 */
var fitDndDevSons = function (sonItems, cldSet, Component) {
    for (let i = 0; i < cldSet.length; i++) {
        let tmpNode = cldSet[i];
        let desId = tmpNode.desId;
        let module = DndDispatch(desId, tmpNode, Component);
        if (!module) {
            continue;
        }
        sonItems.push(module);
        if (tmpNode.cldSet && tmpNode.cldSet.length > 0) {
            module.props.children = [];
            fitDndDevSons(module.props.children, tmpNode.cldSet, module);
            delete tmpNode.cldSet;
        }
    }
}

/**
 * 根据唯一标示，从数据中找到相应的组件数据
 * @param {*} rootChildren 
 * @param {*} dnd_id 
 */
var findNodeByDndID = function (rootChildren, dnd_id) {
    if (!rootChildren) {
        rootChildren = getRootChildren();
    }
    if (!rootChildren || !dnd_id) {
        return;
    }
    for (let i = 0; i < rootChildren.length; i++) {
        let tmpNode = rootChildren[i];
        let tmp_dnd_id = tmpNode.dnd_id;
        if (dnd_id === tmp_dnd_id) {
            return tmpNode;
        }
        if (tmpNode.cldSet && tmpNode.cldSet.length > 0) {
            let result = findNodeByDndID(tmpNode.cldSet, dnd_id);
            if (result) return result;
        }
    }
}


export {
    dropTarget, initRootChildren,
    getRootChildren, initMainUI, initDndDevMain,
    getMainUI, updateUIJson, fitUIJsonDndID,
    setCurrentSelMoudle, getCurrentSelMoudle,
    setCurrentSelPraentMoudle, getCurrentSelPraentMoudle,
    findNodeByDndID, getShowModule
};
