import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { DragSource } from 'react-dnd'


const style = {
    border: '1px dashed gray',
    backgroundColor: 'white',
    padding: '1px 1px 5px 0px',
    marginRight: '4px',
    marginBottom: '5px',
    float: 'left',
    height: '30px',
    width: '70px',
    textAlign: 'center',
    lineHeight: '30px'
}


const boxSource = {
    beginDrag(props) {
        return {
            name: props.name,
            type: props.type,
            desId: props.desId,
        }
    },

    endDrag(props, monitor, component) {
        const item = monitor.getItem()
        // console.log(item);
        const dropResult = monitor.getDropResult();
        // console.log(dropResult);
    },
}

class Box extends Component {
    constructor(props) {
        super(props);

        //初始化state属性
        this.state = {

        };
    }

    render() {
        const { isDragging, connectDragSource } = this.props
        const { name } = this.props
        const opacity = isDragging ? 0.4 : 1

        return connectDragSource(<div style={{ ...style, opacity }}>{name}</div>)
    }
}

export default DragSource("enter", boxSource, (connect, monitor) => ({
    connectDragSource: connect.dragSource(),
    isDragging: monitor.isDragging(),
}))(Box)