'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Input, Button, Icon } from 'antd';
import { Radio } from 'antd';
const RadioGroup = Radio.Group;
import { Checkbox, InputNumber, Select } from 'antd';
import { Tabs } from 'antd';
const TabPane = Tabs.TabPane;
import { Collapse } from 'antd';
const { TextArea } = Input;
const Panel = Collapse.Panel;
const FormItem = Form.Item;
import { updateUIJson } from './DndDispatch'

const formItemLayout = {
    labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
    },
    wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
    },
};

class Dnd_SgiButtonEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };

        // this.state.values = this.props.values;
        // console.log(Dnd_SgiFormPanelEditor)
        // this.refresh('cId',this.props.values.cId);
    }

    // refresh() {
    //     this.setState({ loading: false });
    // }

    setValues(values) {
        this.setState(values);
    }

    textOnChange(attname, e, e2) {
        let value = e.target.value;
        this.refresh(attname, value);
    }

    numberOnChange(attname, e) {
        let value = e;
        this.refresh(attname, value);
    }

    checkOnChange(attname, e) {
        let value = e.target.checked;
        this.refresh(attname, value);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiButton_SgiButton.refresh();

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        // console.log('textEditorRender');
        this.state.values = this.props.values;

        let attEditor = (<Form>
            <Row>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"组件ID"}>
                        <Input value={this.state.values.cId} onChange={this.textOnChange.bind(this, 'cId')} />
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"名称"}>
                        <Input value={this.state.values.n} onChange={this.textOnChange.bind(this, 'n')} />
                    </FormItem>
                </Col>
                <Col span={4}>
                    <FormItem labelCol={{ span: 18 }} label={"禁用"}>
                        <Checkbox checked={this.state.values.isDis} onChange={this.checkOnChange.bind(this, 'isDis')} />
                    </FormItem>
                </Col>
                <Col span={4}>
                    <FormItem labelCol={{ span: 18 }} label={"隐藏"}>
                        <Checkbox checked={this.state.values.isHdn} onChange={this.checkOnChange.bind(this, 'isHdn')} />
                    </FormItem>
                </Col>
            </Row>
            <Row>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"显示名称"}>
                        <Input value={this.state.values.te} onChange={this.textOnChange.bind(this, 'te')} />
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"右上角标"}>
                        <Input value={this.state.values.badgeText} onChange={this.textOnChange.bind(this, 'badgeText')} />
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"提示信息"}>
                        <Input value={this.state.values.hvInfo} onChange={this.textOnChange.bind(this, 'hvInfo')} />
                    </FormItem>
                </Col>
            </Row>
            <Row>
                <Col span={16}>
                    <FormItem labelCol={{ span: 4 }} wrapperCol={{ span: 20 }} label={"显示样式"}>
                        <RadioGroup value={this.state.values.csstyle} onChange={this.textOnChange.bind(this, 'csstyle')}>
                            <Radio value={''}>默认</Radio>
                            <Radio value={'button-primary'}>重要</Radio>
                            {/* <Radio value={'button-danger'}>警告</Radio> */}
                            <Radio value={'button-danger'}>危险</Radio>
                            <Radio value={'button-auxiliary'}>辅助</Radio>
                        </RadioGroup>
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"按钮图片"}>
                        <Input value={this.state.values.btnIconPh} onChange={this.textOnChange.bind(this, 'btnIconPh')} />
                    </FormItem>
                </Col>
            </Row>
            <Row>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"组件宽度"}>
                        <Input value={this.state.values.ctlW} onChange={this.textOnChange.bind(this, 'ctlW')} />
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"组件高度"}>
                        <Input value={this.state.values.ctlH} onChange={this.textOnChange.bind(this, 'ctlH')} />
                    </FormItem>
                </Col>
            </Row>
            <Row>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"外边距"}>
                        <Input value={this.state.values.mgn} onChange={this.textOnChange.bind(this, 'mgn')} />
                    </FormItem>
                </Col>
                <Col span={8}>
                    <FormItem {...formItemLayout} label={"内边距"}>
                        <Input value={this.state.values.pad} onChange={this.textOnChange.bind(this, 'pad')} />
                    </FormItem>
                </Col>
            </Row>
        </Form >);

        let funEditor = (
            <Collapse defaultActiveKey={['1']} accordion>
                <Panel header="点击事件" key="1">
                    <TextArea value={this.state.values.clkLsn} style={{ height: '300px' }} onChange={this.textOnChange.bind(this, 'clkLsn')} />
                </Panel>
            </Collapse>
        )

        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                <Tabs defaultActiveKey="1">
                    <TabPane tab="属性编辑" key="1">{attEditor}</TabPane>
                    <TabPane tab="绑定事件" key="2">{funEditor}</TabPane>
                </Tabs>
            </div>
        )
    }
}

export { Dnd_SgiButtonEditor };