import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiCol } from '../sgiLayout/SgiCol';
import { SgiColEO } from '../sgiCompEO/SgiColEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'
// import sgiColStyle from './Dnd_SgiCol.css'

function getStyle() {
	return {
		minHeight: '42px',
		// height: '35px',
		width: '100%',
		padding: '2px',
		textAlign: 'center',
		// lineHeight: '60px',
		float: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiCol extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = SgiColEO
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	// toggleHover() {
	// 	if (!this.state.hover) {
	// 		this.state.style.border = '1px dashed red'
	// 	} else {
	// 		this.state.style.border = '1px dashed grey'
	// 	}
	// 	// console.log("style.border", this.state.style.border);
	// 	this.state.hover = !this.state.hover;
	// 	this.setState({ hover: this.state.hover })
	// }

	refresh() {
		// this.setState({ loading: false });

		this.refs.Dnd_SgiCol_SgiCol.refresh();
	}

	render() {
		const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
		const isActive = isOverCurrent;

		let backgroundColor = ''
		if (isActive) {
			backgroundColor = 'darkgreen'
		} else if (canDrop) {
			backgroundColor = 'darkkhaki'
		}

		return (
			<SgiCol ref={'Dnd_SgiCol_SgiCol'} moduleDesc={this.state.moduleDesc} type={this.props.type}>
				{connectDropTarget(<div style={{ ...this.state.style, backgroundColor }} {...this.state.toggleHover}>
					{this.state.sonItems}
				</div>)}
			</SgiCol>
		)
	}
}

const boxTarget = {
	drop(props, monitor, Component) {
		DndDispatch.dropTarget(props, monitor, Component);
	}
}


var collect = (connect, monitor) => ({
	connectDropTarget: connect.dropTarget(),
	isOver: monitor.isOver(),
	canDrop: monitor.canDrop(),
	isOverCurrent: monitor.isOver({ shallow: true }),
})


export default DropTarget("enter", boxTarget, collect)(Dnd_SgiCol)