'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Input, Button, Icon } from 'antd';
import { Checkbox, InputNumber, Select } from 'antd';
const FormItem = Form.Item;
import { Tabs } from 'antd';
const TabPane = Tabs.TabPane;
import { Collapse } from 'antd';
const { TextArea } = Input;
const Panel = Collapse.Panel;

import { updateUIJson } from './DndDispatch'

const formItemLayout = {
    labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
    },
    wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
    },
};

class Dnd_SgiColEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };
        // this.state.values = this.props.values;
        // console.log(this.state.values);
    }

    refresh() {
        this.setState({ loading: false });
    }

    setValues(values) {
        this.setState(values);
    }

    textOnChange(attname, e, e2) {
        let value = e.target.value;
        this.refresh(attname, value);
    }

    numberOnChange(attname, e) {
        let value = e;
        this.refresh(attname, value);
    }

    checkOnChange(attname, e) {
        let value = e.target.checked;
        this.refresh(attname, value);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiCol_SgiCol.refresh();

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        // console.log('textEditorRender');
        this.state.values = this.props.values;
        let attEditor = (
            <Form>
                <Row>
                    <Col span={8}>
                        <FormItem labelCol={{ span: 18 }} wrapperCol={{ span: 6 }} label={"占位(比例24格)"}>
                            <InputNumber defaultValue={0} value={this.state.values.span} onChange={this.numberOnChange.bind(this, 'span')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem labelCol={{ span: 18 }} wrapperCol={{ span: 6 }} label={"栅格左侧的间隔格"}>
                            <InputNumber defaultValue={0} value={this.state.values.offset} onChange={this.numberOnChange.bind(this, 'offset')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"组件宽度"}>
                            <Input value={this.state.values.ctlW} onChange={this.textOnChange.bind(this, 'ctlW')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"组件高度"}>
                            <Input value={this.state.values.ctlH} onChange={this.textOnChange.bind(this, 'ctlH')} />
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        let funEditor = (
            <Collapse defaultActiveKey={['1']} accordion>
                <Panel header="展开事件" key="1">
                    <TextArea value={this.state.values.epdLsn} style={{ height: '300px' }} onChange={this.textOnChange.bind(this, 'epdLsn')} />
                </Panel>
            </Collapse>
        )

        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                <Tabs defaultActiveKey="1">
                    <TabPane tab="属性编辑" key="1">{attEditor}</TabPane>
                    {/* <TabPane tab="绑定事件" key="2">{funEditor}</TabPane> */}
                </Tabs>
            </div>
        )
    }
}

export { Dnd_SgiColEditor };