import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiForm } from '../sgiComp/SgiForm';
import { SgiFormEO } from '../sgiCompEO/SgiFormEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'

function getStyle() {
	return {
		minHeight: '200px',
		width: '100%',
		padding: '2px',
		border: '1px dashed grey'
	}
}

class Dnd_SgiForm extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = SgiFormEO();
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	refresh() {
		// this.setState({ loading: false });
		this.refs.Dnd_SgiForm_SgiForm.refresh();
	}


	render() {

		console.log("renderSgiForm")

		const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
		const isActive = isOverCurrent;

		let backgroundColor = ''
		if (isActive) {
			backgroundColor = 'darkgreen'
		} else if (canDrop) {
			backgroundColor = 'darkkhaki'
		}


		return connectDropTarget(
			<div style={{ ...this.state.style, backgroundColor }} {...this.state.toggleHover}>
				<SgiForm ref={'Dnd_SgiForm_SgiForm'} moduleDesc={this.state.moduleDesc} panelModule={this.props.panelModule} type={this.props.type}>
					{this.state.sonItems}
				</SgiForm>
			</div>
		)
	}
}

const boxTarget = {
	drop(props, monitor, Component) {
		DndDispatch.dropTarget(props, monitor, Component);
	}
}


var collect = (connect, monitor) => ({
	connectDropTarget: connect.dropTarget(),
	isOver: monitor.isOver(),
	canDrop: monitor.canDrop(),
	isOverCurrent: monitor.isOver({ shallow: true }),
})


export default DropTarget("enter", boxTarget, collect)(Dnd_SgiForm)