import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiFormSelect as SgiFormCombobox } from '../sgiComp/SgiFormSelect';
import { SgiFormComboboxEO } from '../sgiCompEO/SgiFormComboboxEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'

function getStyle() {
	return {
		minHeight: '30px',
		width: '100%',
		padding: '2px',
		color: 'red',
		padding: '2px',
		lineHeight: '20px',
		textAlign: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiFormCombobox extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = SgiFormComboboxEO();
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	// refresh() {
	// 	this.refs.Dnd_SgiFormCombobox_SgiFormCombobox.refresh();
	// }


	render() {
		return (
			<div style={{ ...this.state.style }} {...this.state.toggleHover}>
				{this.props.comp_explain ? this.props.comp_explain : null}
				<SgiFormCombobox ref={'Dnd_SgiFormCombobox_SgiFormCombobox'} moduleDesc={this.state.moduleDesc} panelModule={this.props.panelModule} type={this.props.type}>
					{/* {this.state.sonItems} */}
				</SgiFormCombobox>
			</div >
		)
	}
}


export default Dnd_SgiFormCombobox;