'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Checkbox, InputNumber, Input, Select } from 'antd';
import { updateUIJson } from './DndDispatch';
import { getCommAttEditor, getFunEditor, getShowEditor,
    formItemLayout, textOnChange, numberOnChange, selectOnChange, checkOnChange } from './Dnd_SgiFormEditorCommon';

const FormItem = Form.Item;
const Option = Select.Option;
const Search = Input.Search;

class Dnd_SgiFormComboxTreeEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };
        // this.state.values = this.props.values;
        // console.log(this.state.values);
    }

    refresh() {
        this.setState({ loading: false });
    }

    setValues(values) {
        this.setState(values);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiFormComboxTree_SgiFormComboxTree.refresh();
        // currentCtl.fieldCtl_mk(panelModule, moduleDesc, bdInst, objFct, type);
        // currentCtl.setState({ loading: false });

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        this.state.values = this.props.values;
        let commAttEditor = getCommAttEditor(this);
        let attEditor = (
            <Form>
                {commAttEditor}
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"标准代码"}>
                            <Search value={this.state.values.scId} onChange={textOnChange.bind(this, this, 'scId')} 
                                onSearch = {()=>alert("不要点了，先当文本框用吧")}/>
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"绑定实例名"}>
                            <Input value={this.state.values.insName} onChange={textOnChange.bind(this, this, 'insName')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"多选"}>
                            <Checkbox checked={this.state.values.mulSel} onChange={checkOnChange.bind(this, this, 'mulSel')} />
                        </FormItem>
                    </Col>
                <Row>
                </Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"显示属性名"}>
                            <Input value={this.state.values.showKey} onChange={textOnChange.bind(this, this, 'showKey')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"保存属性名"}>
                            <Input value={this.state.values.saveKey} onChange={textOnChange.bind(this, this, 'saveKey')} />
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        let funEditor = getFunEditor(this);
        let showEditor = getShowEditor(attEditor, funEditor);
        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                {showEditor}
            </div>
        )
    }
}

export { Dnd_SgiFormComboxTreeEditor };