'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Checkbox, InputNumber, Input, Select } from 'antd';
import { updateUIJson } from './DndDispatch';
import { getCommAttEditor, getFunEditor, getShowEditor,
    formItemLayout, textOnChange, numberOnChange, selectOnChange, checkOnChange } from './Dnd_SgiFormEditorCommon';

const FormItem = Form.Item;
const Option = Select.Option;

class Dnd_SgiFormEditorEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };
        // this.state.values = this.props.values;
        // console.log(this.state.values);
    }

    refresh() {
        this.setState({ loading: false });
    }

    setValues(values) {
        this.setState(values);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiFormEditor_SgiFormEditor.refresh();
        // currentCtl.fieldCtl_mk(panelModule, moduleDesc, bdInst, objFct, type);
        // currentCtl.setState({ loading: false });

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        this.state.values = this.props.values;
        let commAttEditor = getCommAttEditor(this);
        let attEditor = (
            <Form>
                {commAttEditor}
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"current？？？"}>
                            <Input value={this.state.values.current} onChange={textOnChange.bind(this, this, 'current')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"点状步骤条"}>
                            <Input value={this.state.values.progressDot} onChange={textOnChange.bind(this, this, 'progressDot')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"步骤条方向"}>
                            <Select value={this.state.values.direction} onChange={selectOnChange.bind(this, this, 'direction')}>
                                <Option value="top">上</Option>
                                <Option value="bottom">下</Option>
                                <Option value="left">左</Option>
                                <Option value="right">右</Option>
                            </Select>
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        let funEditor = getFunEditor(this);
        let showEditor = getShowEditor(attEditor, funEditor);
        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                {showEditor}
            </div>
        )
    }
}

export { Dnd_SgiFormEditorEditor };