'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Checkbox, InputNumber, Input, Collapse } from 'antd';
import { updateUIJson } from './DndDispatch';
import { getCommAttEditor, getFunEditor, getShowEditor,
    formItemLayout, textOnChange, numberOnChange, selectOnChange, checkOnChange } from './Dnd_SgiFormEditorCommon';

const FormItem = Form.Item;
const Panel = Collapse.Panel;
const TextArea = Input;

class Dnd_SgiFormPopUIEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };
        // this.state.values = this.props.values;
        // console.log(this.state.values);
    }

    refresh() {
        this.setState({ loading: false });
    }

    setValues(values) {
        this.setState(values);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiFormPopUI_SgiFormPopUI.refresh();
        // currentCtl.fieldCtl_mk(panelModule, moduleDesc, bdInst, objFct, type);
        // currentCtl.setState({ loading: false });

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        this.state.values = this.props.values;
        let commAttEditor = getCommAttEditor(this);
        let attEditor = (
            <Form>
                {commAttEditor}
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"自定义"}>
                            <Checkbox checked={this.state.values.isCustom} onChange={checkOnChange.bind(this, this, 'isCustom')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"页面GUID"}>
                            <Input value={this.state.values.uid} onChange={textOnChange.bind(this, this, 'uid')} />
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        // let funEditor = getFunEditor(this);
        let funEditor = (
            <Collapse defaultActiveKey={['1']} accordion>
                <Panel header="自定义点击事件" key="1">
                    <TextArea value={this.state.values.clkLsn} style={{ height: '300px' }} onChange={textOnChange.bind(this, this, 'clkLsn')} />
                </Panel>
            </Collapse>
        );
        let showEditor = getShowEditor(attEditor, funEditor);
        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                {showEditor}
            </div>
        )
    }
}

export { Dnd_SgiFormPopUIEditor };