'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Checkbox, InputNumber, Input } from 'antd';
import { updateUIJson } from './DndDispatch';
import { getCommAttEditor, getFunEditor, getShowEditor,
    formItemLayout, textOnChange, numberOnChange, selectOnChange, checkOnChange } from './Dnd_SgiFormEditorCommon';

const FormItem = Form.Item;
const Search = Input.Search;

class Dnd_SgiFormRadioEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };
        // this.state.values = this.props.values;
        // console.log(this.state.values);
    }

    refresh() {
        this.setState({ loading: false });
    }

    setValues(values) {
        this.setState(values);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiFormRadio_SgiFormRadio.refresh();
        // currentCtl.fieldCtl_mk(panelModule, moduleDesc, bdInst, objFct, type);
        // currentCtl.setState({ loading: false });

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        this.state.values = this.props.values;
        let commAttEditor = getCommAttEditor(this);
        let attEditor = (
            <Form>
                {commAttEditor}
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"标准代码"}>
                            <Search value={this.state.values.scId} onChange={textOnChange.bind(this, this, 'scId')} 
                                onSearch = {()=>alert("不要点了，先当文本框用吧")}/>
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"默认选中项"}>
                            <Input value={this.state.values.checked} onChange={textOnChange.bind(this, this, 'checked')} />
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        let funEditor = getFunEditor(this);
        let showEditor = getShowEditor(attEditor, funEditor);
        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                {showEditor}
            </div>
        )
    }
}

export { Dnd_SgiFormRadioEditor };