import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiMainComp } from '../sgiComp/SgiMainComp';
// import { SgiMainCompEO } from '../sgiCompEO/SgiMainCompEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'
// import sgiColStyle from './Dnd_SgiCol.css'

function getStyle() {
	return {
		// minHeight: '250px',
		height: '100%',
		width: '100%',
		// marginRight: '1.5rem',
		// marginBottom: '1.5rem',
		color: 'red',
		padding: '2px',
		// textAlign: 'left',
		// fontSize: '1rem',
		lineHeight: '20px',
		// float: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiMainComp extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			// this.state.moduleDesc = SgiMainCompEO();
			this.state.moduleDesc = {};
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	refresh() {
		this.setState({ loading: false });
	}


	render() {
		const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
		const isActive = isOverCurrent;

		let backgroundColor = ''
		if (isActive) {
			backgroundColor = 'darkgreen'
		} else if (canDrop) {
			backgroundColor = 'darkkhaki'
		}

		return connectDropTarget(
			<div style={{ ...this.state.style, backgroundColor }} {...this.state.toggleHover}>
				最外层,主UI
				<SgiMainComp ref={'Dnd_SgiMainComp_SgiMainComp'} objFct={this.props.objFct} type={this.props.type} moduleDesc={this.state.moduleDesc}>
					{this.state.sonItems}
				</SgiMainComp>
			</div>
		)
	}

}

const boxTarget = {
	drop(props, monitor, Component) {
		DndDispatch.dropTarget(props, monitor, Component);

		const { isOverCurrent } = Component.props

		//拖拽目的地
		if (!isOverCurrent) {
			return;
		}
		Component.refs.Dnd_SgiMainComp_SgiMainComp.refresh();
	}
}


var collect = (connect, monitor) => ({
	connectDropTarget: connect.dropTarget(),
	isOver: monitor.isOver(),
	canDrop: monitor.canDrop(),
	isOverCurrent: monitor.isOver({ shallow: true }),
})


export default DropTarget("enter", boxTarget, collect)(Dnd_SgiMainComp)