import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiRow } from '../sgiLayout/SgiRow';
import { SgiRowEO } from '../sgiCompEO/SgiRowEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'
// import sgiColStyle from './Dnd_SgiCol.css'

function getStyle() {
	return {
		// minHeight: '250px',
		minHeight: '48px',
		// height: '35px',
		// width: '100%',
		// marginRight: '1.5rem',
		// marginBottom: '1.5rem',
		// color: 'red',
		// padding: '2px',
		// textAlign: 'left',
		// fontSize: '1rem',
		// lineHeight: '48px',
		// float: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiRow extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.sonItems || this.props.children || [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = Dnd_SgiRowEO();
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	refresh() {
		// this.setState({ loading: false });
		this.refs.Dnd_SgiRow_SgiRow.refresh();
	}

	render() {
		const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
		const isActive = isOverCurrent;

		let backgroundColor = ''
		if (isActive) {
			backgroundColor = 'darkgreen'
		} else if (canDrop) {
			backgroundColor = 'darkkhaki'
		}

		return connectDropTarget(
			<div style={{ ...this.state.style, backgroundColor }} {...this.state.toggleHover}>
				{/* {this.props.comp_explain ? this.props.comp_explain : null} */}
				<SgiRow ref={'Dnd_SgiRow_SgiRow'} type={this.props.type} moduleDesc={this.state.moduleDesc}>
					{this.state.sonItems}
				</SgiRow>
			</div>
		)
	}

}

const boxTarget = {
	drop(props, monitor, Component) {
		DndDispatch.dropTarget(props, monitor, Component);
	}
}


var collect = (connect, monitor) => ({
	connectDropTarget: connect.dropTarget(),
	isOver: monitor.isOver(),
	canDrop: monitor.canDrop(),
	isOverCurrent: monitor.isOver({ shallow: true }),
})


export default DropTarget("enter", boxTarget, collect)(Dnd_SgiRow)