import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiSplitter } from '../sgiComp/SgiSplitter';
import { SgiSplitterEO } from '../sgiCompEO/SgiSplitterEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'
// import sgiColStyle from './Dnd_SgiCol.css'

function getStyle() {
	return {
		minHeight: '250px',
		// height: '35px',
		width: '100%',
		// marginRight: '1.5rem',
		// marginBottom: '1.5rem',
		color: 'red',
		padding: '2px',
		textAlign: 'left',
		// fontSize: '1rem',
		lineHeight: '20px',
		float: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiSplitter extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = SgiSplitterEO();
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	refresh() {
		// this.setState({ loading: false });
		this.refs.Dnd_SgiSplitter_SgiSplitter.refresh();
	}

	render() {
		const { canDrop, isOverCurrent, isOver, allowedDropEffect, connectDropTarget } = this.props
		const isActive = isOverCurrent;

		let backgroundColor = ''
		if (isActive) {
			backgroundColor = 'darkgreen'
		} else if (canDrop) {
			backgroundColor = 'darkkhaki'
		}

		return connectDropTarget(
			<div style={{ ...this.state.style, backgroundColor }} {...this.state.toggleHover}>
				{this.props.comp_explain ? this.props.comp_explain : null}
				<SgiSplitter ref={'Dnd_SgiSplitter_SgiSplitter'} type={this.props.type} moduleDesc={this.state.moduleDesc}>
					{this.state.sonItems}
				</SgiSplitter>
			</div>
		)
	}

}

const boxTarget = {
	drop(props, monitor, Component) {
		DndDispatch.dropTarget(props, monitor, Component);

		const { isOverCurrent } = Component.props

		//拖拽目的地
		if (!isOverCurrent) {
			return;
		}
		//修改分割信息
		let sptSca = Component.props.moduleDesc.sptSca;
		if (!sptSca) {
			sptSca = "50";
		} else {
			sptSca = sptSca + ",50";
		}
		Component.props.moduleDesc.sptSca = sptSca;
		//修改了数据要保存到相应的组件数据中
		DndDispatch.updateUIJson(Component.props.moduleDesc.dnd_id, "sptSca", sptSca);
		Component.refs.Dnd_SgiSplitter_SgiSplitter.refresh();
	}
}


var collect = (connect, monitor) => ({
	connectDropTarget: connect.dropTarget(),
	isOver: monitor.isOver(),
	canDrop: monitor.canDrop(),
	isOverCurrent: monitor.isOver({ shallow: true }),
})


export default DropTarget("enter", boxTarget, collect)(Dnd_SgiSplitter)