import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource } from 'react-dnd';
import { DropTarget } from 'react-dnd'
import { SgiTable } from '../sgiComp/SgiTable';
import { SgiTableEO } from '../sgiCompEO/SgiTableEO'
import * as DndDispatch from './DndDispatch'
import { addTabCtlDndInfoForDnd } from './sgiDndDevComFun'

function getStyle() {
	return {
		minHeight: '200px',
		width: '100%',
		padding: '2px',
		color: 'red',
		padding: '2px',
		lineHeight: '20px',
		textAlign: 'left',
		border: '1px dashed grey'
	}
}

class Dnd_SgiTable extends Component {
	constructor(props) {
		super(props);

		//初始化state属性
		this.state = {
			loading: false,
			desid: '',
			sonItems: this.props.children ? this.props.children : [],
			hover: false,
			style: getStyle(),
			toggleHover: {}
		};

		let { moduleDesc } = this.props;
		if (moduleDesc) {
			this.state.moduleDesc = moduleDesc
		} else {
			this.state.moduleDesc = SgiTableEO();
		}
		addTabCtlDndInfoForDnd(this, this.state.toggleHover, this.props.type);
	}

	refresh() {
		// this.setState({ loading: false });
		this.refs.Dnd_SgiTable_SgiTable.refresh();
	}


	render() {
		return (
			<div style={{ ...this.state.style }} {...this.state.toggleHover}>
				{this.props.comp_explain ? this.props.comp_explain : null}
				<SgiTable ref={'Dnd_SgiTable_SgiTable'} moduleDesc={this.state.moduleDesc} panelModule={this.props.panelModule} type={this.props.type}>
					{/* {this.state.sonItems} */}
				</SgiTable>
			</div >
		)
	}
}


export default Dnd_SgiTable;