'use strict';

import React from 'react';
import ReactDOM from 'react-dom';
import { Form, Row, Col, Input, Button, Icon } from 'antd';
import { Checkbox, InputNumber, Select, Table, Divider } from 'antd';
const FormItem = Form.Item;
const { Column, ColumnGroup } = Table;
import { Tabs } from 'antd';
const TabPane = Tabs.TabPane;
import { Collapse } from 'antd';
const { TextArea } = Input;
const Panel = Collapse.Panel;
import { updateUIJson } from './DndDispatch'
import { Dnd_SgiTableColumnsEditor } from './Dnd_SgiTableColumnsEditor'


const formItemLayout = {
    labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
    },
    wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
    },
};

class Dnd_SgiTableEditor extends React.Component {

    constructor(props) {
        super(props);
        this.state = { loading: false };

        // this.state.values = this.props.values;
        // console.log(Dnd_SgiTablePanelEditor)
        // this.refresh('cId',this.props.values.cId);
    }

    // refresh() {
    //     this.setState({ loading: false });
    // }

    setValues(values) {
        this.setState(values);
    }

    textOnChange(attname, e, e2) {
        let value = e.target.value;
        this.refresh(attname, value);
    }

    numberOnChange(attname, e) {
        let value = e;
        this.refresh(attname, value);
    }

    checkOnChange(attname, e) {
        let value = e.target.checked;
        this.refresh(attname, value);
    }

    refresh(attname, value) {
        this.state.values[attname] = value;
        this.setState({ loading: false });

        let currentCtl = this.props.currentCtl;
        var { panelModule, moduleDesc, bdInst, objFct, type } = currentCtl.props;
        moduleDesc[attname] = value;
        //组装属性 初始化属性到this.state
        currentCtl.refs.Dnd_SgiTable_SgiTable.refresh();

        //修改描述信息
        updateUIJson(moduleDesc.dnd_id, attname, value);
    }

    render() {
        // console.log('textEditorRender');
        this.state.values = this.props.values;
        let attEditor = (
            <Form>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"组件ID"}>
                            <Input value={this.state.values.cId} onChange={this.textOnChange.bind(this, 'cId')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"名称"}>
                            <Input value={this.state.values.n} onChange={this.textOnChange.bind(this, 'n')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"显示边框"}>
                            <Checkbox checked={this.state.values.isBrdr} onChange={this.checkOnChange.bind(this, 'isBrdr')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"可编辑"}>
                            <Checkbox checked={this.state.values.isEd} onChange={this.checkOnChange.bind(this, 'isEd')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"标题"}>
                            <Input value={this.state.values.te} onChange={this.textOnChange.bind(this, 'te')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"显示标题"}>
                            <Checkbox checked={this.state.values.isTtl} onChange={this.checkOnChange.bind(this, 'isTtl')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"绑定实例名"}>
                            <Input value={this.state.values.insName} onChange={this.textOnChange.bind(this, 'insName')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"绑定TV编码"}>
                            <Input value={this.state.values.cluDes} onChange={this.textOnChange.bind(this, 'cluDes')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"行选方式"}>
                            <Select defaultValue="left" value={this.state.values.rowSMd} onChange={this.numberOnChange.bind(this, 'rowSMd')}>
                                <Option value="0">单选</Option>
                                <Option value="1">多选</Option>
                            </Select>
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"分批对象名称"}>
                            <Input value={this.state.values.BObjN} onChange={this.textOnChange.bind(this, 'BObjN')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"分批服务GUID"}>
                            <Input value={this.state.values.BSrvGUID} onChange={this.textOnChange.bind(this, 'BSrvGUID')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"分批"}>
                            <Checkbox checked={this.state.values.isBatch} onChange={this.checkOnChange.bind(this, 'isBatch')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"隐藏列头"}>
                            <Checkbox checked={this.state.values.isHeaders} onChange={this.checkOnChange.bind(this, 'isHeaders')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"显示表格线"}>
                            <Checkbox checked={this.state.values.isTbSpt} onChange={this.checkOnChange.bind(this, 'isTbSpt')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"选择首行"}>
                            <Checkbox checked={this.state.values.selFirst} onChange={this.checkOnChange.bind(this, 'selFirst')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"显示行号"}>
                            <Checkbox checked={this.state.values.isRowNo} onChange={this.checkOnChange.bind(this, 'isRowNo')} />
                        </FormItem>
                    </Col>
                    <Col span={4}>
                        <FormItem labelCol={{ span: 18 }} label={"显示搜索框"}>
                            <Checkbox checked={this.state.values.isSch} onChange={this.checkOnChange.bind(this, 'isSch')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"组件宽度"}>
                            <Input value={this.state.values.ctlW} onChange={this.textOnChange.bind(this, 'ctlW')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"组件高度"}>
                            <Input value={this.state.values.ctlH} onChange={this.textOnChange.bind(this, 'ctlH')} />
                        </FormItem>
                    </Col>
                </Row>
                <Row>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"外边距"}>
                            <Input value={this.state.values.mgn} onChange={this.textOnChange.bind(this, 'mgn')} />
                        </FormItem>
                    </Col>
                    <Col span={8}>
                        <FormItem {...formItemLayout} label={"内边距"}>
                            <Input value={this.state.values.pad} onChange={this.textOnChange.bind(this, 'pad')} />
                        </FormItem>
                    </Col>
                </Row>
            </Form >
        )

        let funEditor = (
            <Collapse defaultActiveKey={['1']} accordion>
                <Panel header="点击事件" key="1">
                    <TextArea value={this.state.values.iCLsn} style={{ height: '300px' }} onChange={this.textOnChange.bind(this, 'iCLsn')} />
                </Panel>
            </Collapse>
        )

        let columnEditor = (
            <Table dataSource={[]}>
                <ColumnGroup title="Name">
                    <Column
                        title="First Name"
                        dataIndex="firstName"
                        key="firstName"
                    />
                    <Column
                        title="Last Name"
                        dataIndex="lastName"
                        key="lastName"
                    />
                </ColumnGroup>
                <Column
                    title="Age"
                    dataIndex="age"
                    key="age"
                />
                <Column
                    title="Address"
                    dataIndex="address"
                    key="address"
                />
                <Column
                    title="Action"
                    key="action"
                    render={(text, record) => (
                        <span>
                            <a href="javascript:;">Action 一 {record.name}</a>
                            <Divider type="vertical" />
                            <a href="javascript:;">Delete</a>
                            <Divider type="vertical" />
                            <a href="javascript:;" className="ant-dropdown-link">
                                More actions <Icon type="down" />
                            </a>
                        </span>
                    )}
                />
            </Table>
        )

        return (
            <div style={{ height: '500px', overflow: 'auto' }}>
                <Tabs defaultActiveKey="1">
                    <TabPane tab="属性编辑" key="1">{attEditor}</TabPane>
                    <TabPane tab="表格列编辑" key="2"><Dnd_SgiTableColumnsEditor currentCtl={this.props.currentCtl} /></TabPane>
                    <TabPane tab="绑定事件" key="3">{funEditor}</TabPane>
                </Tabs>
            </div>
        )
    }
}

export { Dnd_SgiTableEditor };