import React from 'react';
import ReactDOM from 'react-dom';
import * as DndDispatch from './DndDispatch'
import { Dnd_SgiFormTextEditor } from './Dnd_SgiFormTextEditor'
import { Dnd_SgiFormTextAreaEditor } from './Dnd_SgiFormTextAreaEditor'
import { Dnd_SgiFormNumberEditor } from './Dnd_SgiFormNumberEditor'
import { Dnd_SgiFormDateEditor } from './Dnd_SgiFormDateEditor'
import { Dnd_SgiFormTimeEditor } from './Dnd_SgiFormTimeEditor'
import { Dnd_SgiFormFileEditor } from './Dnd_SgiFormFileEditor'
import { Dnd_SgiFormComboboxEditor } from './Dnd_SgiFormComboboxEditor'
import { Dnd_SgiFormCheckboxEditor } from './Dnd_SgiFormCheckboxEditor'
import { Dnd_SgiFormCheckboxGroupEditor } from './Dnd_SgiFormCheckboxGroupEditor'
import { Dnd_SgiFormRadioEditor } from './Dnd_SgiFormRadioEditor'
import { Dnd_SgiFormPopUIEditor } from './Dnd_SgiFormPopUIEditor'
import { Dnd_SgiFormEditorEditor } from './Dnd_SgiFormEditorEditor'
import { Dnd_SgiFormComboxTreeEditor } from './Dnd_SgiFormComboxTreeEditor';
import { Dnd_SgiTabsEditor } from './Dnd_SgiTabsEditor'
import { Dnd_SgiPanelEditor } from './Dnd_SgiPanelEditor'
import { Dnd_SgiCollapseEditor } from './Dnd_SgiCollapseEditor'
import { Dnd_SgiCardEditor } from './Dnd_SgiCardEditor'
import { Dnd_SgiSplitterEditor } from './Dnd_SgiSplitterEditor'
import { Dnd_SgiFormEditor } from './Dnd_SgiFormEditor'
import { Dnd_SgiNestEditor } from './Dnd_SgiNestEditor'
import { Dnd_SgiTreeEditor } from './Dnd_SgiTreeEditor'
import { Dnd_SgiTableEditor } from './Dnd_SgiTableEditor'
import { Dnd_SgiButtonEditor } from './Dnd_SgiButtonEditor'
import { Dnd_SgiToolbarEditor } from './Dnd_SgiToolbarEditor'
import { Dnd_SgiMainCompEditor } from './Dnd_SgiMainCompEditor'
import { Dnd_SgiColEditor } from './Dnd_SgiColEditor'
import { Dnd_SgiRowEditor } from './Dnd_SgiRowEditor'
import { uuid, Array } from "../sgiCommon/sgiCommon";
import { Resource } from '../sgiCommon/Resource';
import { Tabs, Collapse } from 'antd';
import { Form, Modal, Button, Row, Col } from 'antd';
const TabPane = Tabs.TabPane;
const Panel = Collapse.Panel;
import { updateUIJson, setCurrentSelMoudle, setCurrentSelPraentMoudle } from './DndDispatch'


function onDBClick(event) {
    // console.log(arguments);
    // console.log("thisModule", this);
    let mainUI = DndDispatch.getMainUI();
    fitModalInfo(this);
    mainUI.openModal();
    event.cancelBubble = true; //ie浏览器 组织向下传递
    event.stopPropagation(); //chrome等浏览器
}


/**
 * 组装弹出框 编辑信息
 */
function fitModalInfo(module) {
    let mainUI = DndDispatch.getMainUI();
    mainUI.state.modal_title = module.props.modal_title;
    if ('Dnd_SgiFormTextEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormTextEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiTabsEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiTabsEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiPanelEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiPanelEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiCollapseEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiCollapseEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiCardEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiCardEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiSplitterEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiSplitterEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiNestEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiNestEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiTreeEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiTreeEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiTableEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiTableEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiButtonEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiButtonEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiToolbarEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiToolbarEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiMainCompEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiMainCompEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiRowEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiRowEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiColEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiColEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormTextAreaEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormTextAreaEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormNumberEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormNumberEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormDateEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormDateEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormTimeEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormTimeEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormFileEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormFileEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormComboboxEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormComboboxEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormCheckboxEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormCheckboxEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormCheckboxGroupEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormCheckboxGroupEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormRadioEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormRadioEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormPopUIEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormPopUIEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormEditorEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormEditorEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else if ('Dnd_SgiFormComboxTreeEditor' === module.props.modal_context) {
        mainUI.state.modal_context = <Dnd_SgiFormComboxTreeEditor values={module.props.moduleDesc} currentCtl={module} />;
    } else {
        mainUI.state.modal_context = <div style={{ height: '300px' }}><h1>不是UI内部的控件，现阶段不能直接编辑</h1></div>;
    }
}

function onClick(moudule, event) {

    let parentModule = moudule.props.parentModule;
    setCurrentSelMoudle(moudule); //设置当前选中节点
    setCurrentSelPraentMoudle(parentModule); //设置当前选中父节点

    fitModalInfo(moudule);
    let mainUI = DndDispatch.getMainUI(); //切到组件编辑面板

    mainUI.state.CurrentSelMoudlete = moudule.props.moduleDesc.te || moudule.props.moduleDesc.n;
    mainUI.state.CurrentSelMoudleguid = moudule.props.modal_title;
    // mainUI.setState({ activeKey: 'x' });
    mainUI.setState({ loading: true });

    if (event) {
        event.cancelBubble = true; //ie浏览器 组织向下传递
        event.stopPropagation(); //chrome等浏览器
    }
}


function toggleHover(moudule, event) { //给树点击用
    //this.state.style给拖拽控件使用的 formItemProps给sgiform控件使用的
    let props = moudule.state.formItemProps || moudule.inputprops || moudule.state;
    // if (!moudule.state.hover) {
    props.style.border = '2px dashed blue'
    // } else {
    //     props.style.border = '1px dashed grey'
    // }
    moudule.setState({ hover: !moudule.state.hover });
}

function toggleHoverEnter(moudule, event) {
    //this.state.style给拖拽控件使用的 formItemProps给sgiform控件使用的
    let props = moudule.state.formItemProps || moudule.inputprops || moudule.state;
    // if (!moudule.state.hover) {
    props.style.border = '2px dashed red'
    // } else {
    //     props.style.border = '1px dashed grey'
    // }
    moudule.setState({ hover: !moudule.state.hover });
    if (event) {
        event.cancelBubble = true; //ie浏览器 组织向下传递
        event.stopPropagation(); //chrome等浏览器
    }
}

function toggleHoverLeave(moudule, event) {
    //this.state.style给拖拽控件使用的 formItemProps给sgiform控件使用的
    let props = moudule.state.formItemProps || moudule.inputprops || moudule.state;
    // if (!moudule.state.hover) {
    //     props.style.border = '1px dashed red'
    // } else {
    props.style.border = '1px dashed grey'
    // }
    moudule.setState({ hover: !moudule.state.hover });
    // if (event) {
    //     event.cancelBubble = true; //ie浏览器 组织向下传递
    //     event.stopPropagation(); //chrome等浏览器
    // }
}

function addMouseFun(moudule, params) {
    params.onMouseEnter = toggleHoverEnter.bind(moudule, moudule);
    params.onMouseLeave = toggleHoverLeave.bind(moudule, moudule);
    // params.onMouseLeave = toggleHover.bind(moudule, moudule);
}

/**
 * 对外接口,添加拖拽布局
 * @param {控件样式} style 
 */
// function addFormCtlDndInfo(moudule, formItemProps, inputprops, type) {
//     if (type != "dnd") {
//         return;
//     }
//     //状态中追加一个hover状态,默认为false
//     moudule.state.hover = false;
//     addMouseFun(moudule, inputprops);
//     inputprops.onDoubleClick = onDBClick.bind(moudule);
//     inputprops.onClick = onClick.bind(moudule);
//     formItemProps.style.border = '1px dashed grey';
// }


/**
 * 对外接口,tab添加拖拽布局，解决鼠标滑过变色问题和点击事件编辑
 * @param {控件样式} style 
 */
function addTabCtlDndInfoForDnd(moudule, tabsProps, type) {
    if (type != "dnd") {
        return;
    }
    //状态中追加一个hover状态,默认为false
    moudule.state.hover = false;
    addMouseFun(moudule, tabsProps);
    tabsProps.onDoubleClick = onDBClick.bind(moudule);
    tabsProps.onClick = onClick.bind(moudule, moudule);
}

/**
 * 对外接口,tab添加拖拽布局
 * @param {控件样式} style 
 */
function addTabCtlDndInfo(moudule, tabsItems, tabsProps, type) {
    if (type != "dnd") {
        return;
    }
    let cldSet = moudule.props.children;
    if (cldSet && cldSet.length && cldSet.length > 0) {
        let tabPane;
        cldSet.forEach((item, index) => {
            let { cId, te, isDis } = item.props.moduleDesc;
            tabPane = {};
            if (!cId) {
                cId = uuid(8);
                item.props.moduleDesc.cId = cId; //赋值的同时，也要给json数据赋值，保持同步
                updateUIJson(item.props.moduleDesc.dnd_id, "cId", cId);
            }
            if (te) tabPane.tab = Resource.getTRByPrm(item.props.moduleDesc).te;
            if (cId) tabPane.key = cId;
            if (isDis) tabPane.disabled = isDis;
            item.props.panelModule = moudule;
            tabsItems.push(<TabPane {...tabPane}>{item}</TabPane>);
        });
    }
}

/**
 * 对外接口,Collapse添加拖拽布局
 * @param {控件样式} style 
 */
function addCollapseCtlDndInfo(moudule, tabsItems, tabsProps, type) {
    if (type != "dnd") {
        return;
    }

    let cldSet = moudule.props.children;
    if (cldSet && cldSet.length && cldSet.length > 0) {
        let cosPane;
        cldSet.forEach((item, index) => {
            let { cId, te, isDis } = item.props.moduleDesc;
            cosPane = {};
            if (!cId) {
                cId = uuid(8);
                item.props.moduleDesc.cId = cId; //赋值的同时，也要给json数据赋值，保持同步
                updateUIJson(item.props.moduleDesc.dnd_id, "cId", cId);
            }
            if (te) cosPane.header = Resource.getTRByPrm(item.props.moduleDesc).te;
            if (cId) cosPane.key = cId;
            if (isDis) cosPane.disabled = isDis;
            item.props.panelModule = moudule;
            tabsItems.push(<Panel {...cosPane}>{item}</Panel>);
        });
    }
}
/**
 * 对外接口,toolbar添加拖拽布局
 * @param {控件样式} style 
 */
function addToolbarCtlDndInfo(moudule, tabsItems, tabsProps, type) {
    if (type != "dnd") {
        return;
    }

    let cldSet = moudule.props.sonItems;
    var tlbAlg = moudule.props.moduleDesc.tlbAlg;//工具条位置  
    if (cldSet && cldSet.length && cldSet.length > 0) {
        if (!tlbAlg || tlbAlg == "top" || tlbAlg == "bottom") {
            cldSet.forEach((item, index) => {
                tabsItems.push(item);
            });
        } else if (tlbAlg == "left" || tlbAlg == "right") {
            var rowlist = [];
            cldSet.forEach((item, index) => {
                rowlist.push(<Row>{item}</Row>);
            });
            tabsItems.push(
                <Col>{rowlist}</Col>
            );
        }
    }
}

/**
 * 对外接口,Collapse添加拖拽布局
 * @param {控件样式} style 
 */
function addSgiSplitterCtlDndInfo(moudule, tabsItems, tabsProps, type) {
    if (type != "dnd") {
        return;
    }

    let { bdInst, objFct, moduleDesc } = moudule.props;
    let colList;
    //分割比例
    var p = moduleDesc.sptSca;
    var ps = p.split(",");

    //计数
    var sumPs = 0;
    for (var i = 0; i < ps.length; i++) {
        sumPs += parseInt(ps[i]);
    }
    var isEdwSpt = moduleDesc.isEdwSpt;//纵向分割

    colList = [];
    var children = moudule.props.children;
    if (children) {
        var childSize = children.length;
        if (childSize != 0) {
            for (var i = 0; i < childSize; i++) {
                if (!ps[i]) {
                    ps[i] = 0;
                }
                var span = Math.round((parseInt(ps[i]) / sumPs) * 24);
                var height1 = (parseInt(ps[i]) / sumPs) * 100 + "%";

                if (isEdwSpt) {
                    colList.push(<Row style={{ height: height1 }} >
                        {children[i]}</Row>)
                } else {
                    colList.push(<Col span={span} >
                        {children[i]}</Col>)
                }
            }
            if (isEdwSpt) {
                tabsItems.push(colList);
            } else {
                tabsItems.push(<Row>{colList}</Row>);
            }
        }
    }
}

export {
    // addFormCtlDndInfo,
    addTabCtlDndInfo,
    addTabCtlDndInfoForDnd,
    addCollapseCtlDndInfo,
    addSgiSplitterCtlDndInfo,
    addToolbarCtlDndInfo,
    toggleHover,
    onClick,
    toggleHoverLeave
}