/**
 * localStorage
 */
const sgiLocalStorage = {
    localMap: null,
    localSupported: undefined,
    set: function (key, value) {
        // var zip = new JSZip();
        // zip.file(key, value);
        // var text = zip.generate({
        //     'compression': 'DEFLATE',
        //     type: "string"
        // });
        if (this.localStorageSupported()) {
            return window.localStorage.setItem(key, value);
        } else {
            return this.localMap.add(key, value);
        }
    },
    get: function (key) {
        var value;
        if (this.localStorageSupported()) {
            value = window.localStorage.getItem(key);
        } else {
            value = this.localMap.get(key);
        }
        if (value) {
            // var zip = new JSZip();
            // zip.load(value);
            // return zip.file(key).asText();
            return value;
        } else {
            return null;
        }
    },
    clear: function () {
        if (this.localStorageSupported()) {
            window.localStorage.clear();
        } else {

            this.localMap.clear();
        }
    },
    remove: function (key) {
        if (this.localStorageSupported()) {
            window.localStorage.removeItem(key);
        }
        else {
            this.localMap.removeByKey(key);
        }
    },
    length: function () {
        if (this.localStorageSupported()) {
            return window.localStorage.length;

        }
        else {
            return this.localMap.length;
        }
    },
    localStorageSupported: function () {
        var testKey = 'test', storage = window.localStorage;
        if (this.localSupported === undefined) {
            try {
                storage.setItem(testKey, '1');
                storage.removeItem(testKey);
                this.localSupported = true;
            } catch (error) {
                this.localSupported = false;

            }
        }
        return this.localSupported;
    }

}


export { sgiLocalStorage };