/*     对象工厂
 --------------------------------------------------------------------------------
 作者：王哲                           创建日期：2018/03/12
 --------------------------------------------------------------------------------
 提供方法列表：
 ★对象保存
 ★对象读取
 ★根据参数guid创建对象  
 ★对象删除
 --------------------------------------------------------------------------------
 修改：                               修改日期：
 修改内容: 

 --------------------------------------------------------------------------------
 
 *******************************************************************************/
class ObjFactory {

    objFct = null;

    constructor(uid) {
        this.objFct = {};
        if (uid) {
            this.objFct['@currentObjFctUID'] = uid;
        }
    }
    setUID = function (uid) {
        if (uid) {
            this.objFct['@currentObjFctUID'] = uid;
        }
    }
    getUID = function(){
        let uid = this.objFct['@currentObjFctUID'];
        return uid;
    }
    /**
     * 将对象保存到对象工厂中
     * @param {type} pObj
     * @param {type} pInstanceName
     * @returns {undefined}
     */
    set = function (pInstanceName, pObj) {
        if (!pInstanceName) {
            return;
        }
        this.objFct[pInstanceName] = pObj;
    }
    /**
     * 取得对象工厂中缓存的对象
     * @param {type} pInstanceName
     * @returns {unresolved}
     */
    get = function (pInstanceName) {
        if (pInstanceName) {
            return this.objFct[pInstanceName];
        } else {
            return null;
        }
    }
    /**
     * 删除对象工厂中的对象
     * @param {type} pInstanceName
     * @returns {undefined}
     */
    remove = function (pInstanceName) {
        delete this.objFct[pInstanceName];
    }

};

export { ObjFactory }