import React from 'react';
import ReactDOM from 'react-dom';
import { Row, Col } from 'antd';
import { convertModuleByGuid } from "../sgiComp/SgiCompComm";
// const FormItem = Form.Item;

class SgiRow extends React.Component {

    constructor(props) {
        super(props);
        this.state = {};
        let { align, justify, type, ctlW, ctlH } = this.props.moduleDesc;
        /**
         * align	flex 布局下的垂直对齐方式：top middle bottom
         * justify	flex 布局下的水平排列方式：start end center space-around space-between
         * type	布局模式，可选 flex，现代浏览器 下有效
         */
        this.state = {
            rowProps: {},
            loading: false
        };
    }

    /**
   * 根据描述创建form
   * @param {父组件} panelModule 
   * @param {描述} moduleDesc       
   * @param {对象工厂} objFct 
   * @param {make类型} type 
   */
    row_mk(panelModule, moduleDesc, objFct, type) {
        //获取需要展示的数据信息
        if (!moduleDesc) {
            return;
        }
        var sonUIItems = []; //form下控件数组
        //转换基础属性
        this.AddAttribute(moduleDesc, this.state.rowProps);
        //组装form表单下的控件信息
        this.fitSonUIItems(moduleDesc, sonUIItems, objFct, type);

        this.sonUIItems = sonUIItems;
    }

    AddAttribute = function (moduleDesc, rowProps) {
        let { align, justify, style, type, ctlW, ctlH } = this.props.moduleDesc;
        rowProps.style = style;
        rowProps.align = align;
        rowProps.justify = justify;
        rowProps.type = type;

        //嵌入UID
        if (!style) {
            rowProps.style = {};
        }
        if (ctlW) rowProps.style.width = ctlW;
        if (ctlH) rowProps.style.height = ctlH;
    }

    /**
     * 根据描述组装子对象
     * @param {描述信息} moduleDesc 
     * @param {属性} formProps 
     */
    fitSonUIItems = function (moduleDesc, sonUIItems, objFct, type) {
        var me = this;
        //form下的子节点添加到form组件中
        let cldSet = moduleDesc.cldSet;
        if (cldSet && cldSet.length && cldSet.length > 0) {
            cldSet.forEach((item, index) => {
                sonUIItems.push(convertModuleByGuid(me, item, null, objFct, type));
            });

        }
    }

    refresh = () => {
        this.loaded = false;
        this.setState({ loading: false });
    }

    //渲染并返回一个虚拟DOM
    render = function () {
        if (!this.loaded) {
            let { panelModule, moduleDesc, objFct, type } = this.props;
            //组装属性
            this.row_mk(panelModule, moduleDesc, objFct, type);
            this.loaded = true;
        }
        return (
            <Row {...this.state.rowProps}>{this.sonUIItems}
                {this.props.children}</Row>
        );
    }
}

export { SgiRow };